/*****************************************************************************
SPADE

Spherical particle detection from electron micrographs

Copyright (C )1999 T. Kaituri, E. Kallioniemi, J. Paaso,
M. Ters and J. Virtanen

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

*****************************************************************************/

#include <iostream.h>
#include <FL/Fl.H>
//#include <FL/Fl.H>
#include <FL/Fl_Image.H>
#include <fstream.h>

#include "image8bi.h"

#ifndef __JEEJEE__
#define __JEEJEE__


/*
 * Module:   Fileimage
 * Purpose:  For reading the data from mrc file for
 *           processing or viewing, and for saving the data
 * Use:      
 *
 * Synopsis: 
 *
 * Author:   Jarno Virtanen
 * Date:     13.5.1999
 */
struct MRC_header{
       int width, height, section, mode;
};
	
class Fileimage {
 public:

              enum fformats{file_png, file_mrc};  // Saveimage parameter
                   Fileimage(const char *filename);
                   Fileimage () {}
                   ~Fileimage();
             Image *readForProcessing();         // Raw reading (no scaling etc.)
     unsigned char *readForViewing(int, int, int, int, int);
     unsigned char *readForViewing(int, int, int, int, int, int &);
               int xSize() { return _width;  }
               int ySize() { return _height; }
       static void saveImage (const char *filename, unsigned char *data, int sizex,
     		     int sizey, int format);
              char *fullName() { return _name; }
               int status() { return _OK; }     // This is never used!

 private:
            int check();                                      // Checks if file exists etc.
     inline int pixelValue (int, unsigned char *,      // Interpolates pixel value
			    unsigned char *, double, double); 
           void readLine(unsigned char *alku,     // Reads one "interpolation line"
		   ifstream &infile, int realdimx, 
		   int scaledx, int width);
     
       unsigned chEndian (unsigned b);                   // Changes endianess
           bool dataAmountOk(ifstream &file);
           char *_name;
       unsigned _width, _height, _sections, _mode;
            int _OK, _dataOfst;                          // Header size
          short header[1024];            
};

#endif

