/*****************************************************************************
SPADE

Spherical particle detection from electron micrographs

Copyright (C) 1999 T. Kaituri, E. Kallioniemi, J. Paaso,
M. Ters and J. Virtanen

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

*****************************************************************************/
    

#ifndef __IMAGEOPERATION_H
#define __IMAGEOPERATION_H

#include "mask.h"

class Operation {

 public:

     enum manipulation {all, blendstretch, blendcenter, oblend, stretchcenter, 
			ostretch, ocenter, none};
     
     Operation();                         // If no mask is needed
     Operation(int rmaskin, int rmaskout, bool rblend, 
	       bool rcenter, bool rstretch, bool rpercent, int ra, int rb, int kh);
	
     bool usemask()    { return mask; }

     bool useblend();   
     bool usecenter();  
     bool usestretch(); 
     bool usepercent(); 

     manipulation useoperations();

     void setmask(bool, int, int);
     void setblend(bool);
     void setcenter(bool);
     void setstretch(bool ustretch, int, int);
     void setstretch(bool ustretch, int);
     	  
     int getmaskin();
     int getmaskout();

     int getperA();
     int getperB();
     
     int getkh();
	       

 private:
     Mask *realmask;         // Useful?
     
     bool mask;                 // Whether to use mask at all
     int maskin, maskout;       // Inner and outer radius
     
     bool blend, center;        // Indicates if blendWithMask 
                                // or center should be used

     bool stretch;              // sctretch histogram;
     bool percent;              // Whether stretch is measured in percents

     int perA, perB;            // prosentteina
     int keskihajonta;          // keskihajonnan monikerta
};

#endif


