// generated by Fast Light User Interface Designer (fluid) version 1.0008

#include "spade.H"
/*****************************************************************************
SPADE

Spherical particle detection from electron micrographs
Copyright (C) 2000 Anatoly M. Verkhovsky
Copyright (C )1999 T. Kaituri, E. Kallioniemi, J. Paaso,
M. Ters and J. Virtanen

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

*****************************************************************************/
#include <stdarg.h>
#include <signal.h>
static FILE *fp_;
static char *rsrv= new char[500000];
static PrjGroup *Groups=NULL;
static PrjInFile *InFiles=NULL;
static PrjOutFile *OutFiles=NULL;
static int GroupNo=0, InFileNo=0, OutFileNo=0, treefoc=0,CheckSave=0;

void mprintf(char *str,...) {
  char buf[300];
char tmp[300];
int i=0,ii=0;
va_list ap;

memset(buf,0,300);
va_start(ap,str);
while (str[i]!=0){
	if (str[i]=='%') {
		switch (str[i+1]){
			case 'd': 
				sprintf(tmp,"%d",va_arg(ap,int));
				strcat(buf,tmp);ii+=strlen(tmp);i+=2; break;
			case 'f': 
				sprintf(tmp,"%f",va_arg(ap,double));
				strcat(buf,tmp);ii+=strlen(tmp);i+=2; break;
			case 's': 
				sprintf(tmp,"%s",va_arg(ap,char *));
				strcat(buf,tmp);ii+=strlen(tmp);i+=2; break;
		}
	}else buf[ii++]=str[i++];
}

if(fp_){ 
	fprintf(fp_,"%s",buf);
	fflush(fp_);
} else {
	fp_=fopen("spade.log","ab");
	fprintf(fp_,"%s",buf);
	fflush(fp_);	
}
   va_end(ap);


//
}

Fl_Window *wnd_NewGroup=(Fl_Window *)0;

static void cb_Cancel(Fl_Button*, void*) {
  wnd_NewGroup->hide();
}

Fl_Input *tin_GroupName=(Fl_Input *)0;

static void cb_OK(Fl_Button*, void*) {
  //=================================================
//        Update internal data structure
PrjGroup *gr=Groups;
int n=0;
Fl_ToggleNode *nn;

while (gr) {
	if (strcmp(tin_GroupName->value(), gr->grname)==0){
		n=1;
		break;
	}
	gr=gr->next;
}

if (n==0){
	gr= new PrjGroup();
	GroupNo++;
	gr->tag=GROUP;
	strcpy(gr->grname, tin_GroupName->value());
	gr->groupno=GroupNo;
	gr->processed=0;
	gr->next=Groups;
	gr->radius=0;
	gr->box=0;
	Groups=gr;

//         Udate the tree widget

	tree_Unproc->traverse_start();
	char *tmp = strdup(tin_GroupName->value());
	nn=tree_Unproc->add_next( tmp, 1, NULL, gr);
//	printf(" Selection before unselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->unselect();
//	printf(" Selection after unselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->select_range(nn,nn);
//	printf(" Selection after unselect, after rangeselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->traverse_start(nn);
//	printf(" Selection after traverse: %d \n ", tree_Unproc->selected());
//	tree_Unproc->select(nn);
	tree_Proc->unselect();
	
//	if(tree_Unproc->selected()) printf("Node selected\n"); else printf("Not selsected!\n");
	tree_Unproc->do_callback();
	wnd_NewGroup->hide();

// 	Logging group creation
	mprintf(" Added new group: %s\n", gr->grname);
	CheckSave=1;
	if (chb_Autosave->value()==0) {
		btn_PrjSave->activate();
		btn_PrjSave->redraw();
	} 
} else 
   fl_alert(" Group \"%s\" already exists. ",  tin_GroupName->value());



//;
}

Fl_Window *wnd_InspectUnproc=(Fl_Window *)0;

Fl_Menu_Item menu_[] = {
 {"  Filter  ", 0,  0, 0, 64, 0, 1, 14, 0},
 {"  Fourier and RDD  ", 0,  0, 0, 0, 0, 0, 14, 0},
 {"  Histogram  ", 0,  0, 0, 0, 0, 0, 14, 0},
 {"  Line profile", 0,  0, 0, 0, 0, 0, 14, 0},
 {"  Equalize  ", 0,  0, 0, 0, 0, 0, 14, 0},
 {0},
 {0}
};

Fl_Group *grp_UnprocStatus=(Fl_Group *)0;

Fl_Button *btn_stsComment=(Fl_Button *)0;

Fl_Group *grp_Choises=(Fl_Group *)0;

Fl_Group *grpZoomnPan=(Fl_Group *)0;

static void cb_1(Fl_Button*, void*) {
  fl_cursor(FL_CURSOR_WAIT,FL_BLACK,FL_WHITE);
btn_stsComment->label(" Set screen resolution to that of the micrograph");
btn_stsComment->redraw();
Fl::flush();
box_Image->One2One();
//box_Image->redraw();
vout_Zoom->value(1.0);
btn_stsComment->label("");
btn_stsComment->redraw();
Fl::flush();
fl_cursor(FL_CURSOR_DEFAULT,FL_BLACK,FL_WHITE);
}

static void cb_gfx(Fl_Button*, void*) {
  fl_cursor(FL_CURSOR_WAIT,FL_BLACK,FL_WHITE);
btn_stsComment->label(" Shrinking to fit the window");
btn_stsComment->redraw();
//printf("Shrink2fit callback: xsize: %d",box_Image->fim_->xSize());
Fl::flush();
double d=box_Image->Shrink2Fit();
//box_Image->redraw();
vout_Zoom->value(d);
btn_stsComment->label("");
btn_stsComment->redraw();
Fl::flush();
fl_cursor(FL_CURSOR_DEFAULT,FL_BLACK, FL_WHITE);
}

#include <FL/Fl_Pixmap.H>
static unsigned char *image_tofit[] = {
(unsigned char*)
"20 20 -3 1",
(unsigned char*)
"!\300\300\300\"\0\0\0#xxx",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!#\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"\"\"\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"!!!!!!\"!!!!!!",
(unsigned char*)
"!!!!!!\"!!!!!!\"!!!!!!",
(unsigned char*)
"!!!\"#!\"!!!!!!\"!#\"!!!",
(unsigned char*)
"!\"\"\"\"!\"!!!!!!\"!\"\"\"\"!",
(unsigned char*)
"!!!\"#!\"!!!!!!\"!#\"!!!",
(unsigned char*)
"!!!!!!\"!!!!!!\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"\"\"\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!#\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_tofit(image_tofit);

Fl_Button *btn_PanUp=(Fl_Button *)0;

static void cb_btn_PanUp(Fl_Button*, void*) {
  box_Image->PanUp();
box_Image->redraw();
}

static unsigned char *image_ar_up[] = {
(unsigned char*)
"15 15 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!\"!!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!\"\"\"\"\"\"\"!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_ar_up(image_ar_up);

Fl_Button *btn_PanLeft=(Fl_Button *)0;

static void cb_btn_PanLeft(Fl_Button*, void*) {
  box_Image->PanLeft();
box_Image->redraw();
}

static unsigned char *image_ar_left[] = {
(unsigned char*)
"15 15 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!\"!!!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!!!",
(unsigned char*)
"!!!!\"\"\"!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"!!",
(unsigned char*)
"!!\"\"\"\"\"\"\"\"\"\"\"!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"!!",
(unsigned char*)
"!!!!\"\"\"!!!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!!!",
(unsigned char*)
"!!!!!!\"!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_ar_left(image_ar_left);

Fl_Button *btn_PanRight=(Fl_Button *)0;

static void cb_btn_PanRight(Fl_Button*, void*) {
  box_Image->PanRight();
box_Image->redraw();
}

static unsigned char *image_ar_right[] = {
(unsigned char*)
"15 15 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"!!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"!!!!",
(unsigned char*)
"!!\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!\"\"\"\"\"\"\"\"\"\"\"!!",
(unsigned char*)
"!!\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!!!!!!\"\"\"!!!!",
(unsigned char*)
"!!!!!!!!\"\"!!!!!",
(unsigned char*)
"!!!!!!!!\"!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_ar_right(image_ar_right);

Fl_Button *btn_PanDown=(Fl_Button *)0;

static void cb_btn_PanDown(Fl_Button*, void*) {
  box_Image->PanDown();
box_Image->redraw();
}

static unsigned char *image_ar_dn[] = {
(unsigned char*)
"15 15 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!!\"\"\"\"\"\"\"!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!!\"!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_ar_dn(image_ar_dn);

Fl_Value_Output *vout_Zoom=(Fl_Value_Output *)0;

Fl_Group *grp_GroupnFile=(Fl_Group *)0;

Fl_Choice *ch_Group=(Fl_Choice *)0;

Fl_Choice *ch_File=(Fl_Choice *)0;

static void cb_ch_File(Fl_Choice* o, void*) {
  //PrjGroup *gr=Groups;
//PrjInFile *inf=InFiles;
//char *ch=(char *)(o->menu()[o->value()].user_data_);

//printf("Changing current micrograph! %s\n",(char *)o->menu()[o->value()].user_data_ );
int n=btn_EthanPrev->value();

fl_cursor(FL_CURSOR_WAIT,FL_BLACK,FL_WHITE);
btn_stsComment->label(" Switching to new micrograph");
btn_stsComment->redraw();
o->redraw();

char *fname=(char *) (o->menu()[o->value()].user_data_);
Fileimage *im=new Fileimage(fname);

//printf("New file image created!\n");
double d=box_Image->Redisplay(im,0,0,im->xSize(),im->ySize());			 //make suitable pixelmap
//printf("Setting new image!\n");
box_Image->FileImage(im);
box_Image->redraw();

vout_Zoom->value(d);
btn_EthanPrev->value(0);
btn_stsComment->label("");
btn_stsComment->redraw();

//printf("Before preview callback! %d \n", btn_EthanPrev->value());
if (n==1) btn_EthanPrev->do_callback();
//printf("After preview callback!\n");
fl_cursor(FL_CURSOR_DEFAULT,FL_BLACK,FL_WHITE);

//box_Image->redraw_overlay();
}

Fl_Group *grp_Ethan=(Fl_Group *)0;

Fl_Value_Input *vin_Radius=(Fl_Value_Input *)0;

Fl_Value_Input *vin_Box=(Fl_Value_Input *)0;

Fl_Button *btn_EthanPrev=(Fl_Button *)0;

static void cb_btn_EthanPrev(Fl_Button* o, void*) {
  //

if (o->value()==1){
	if (vout_Radius->value()>0){
		fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK, FL_WHITE);
		btn_stsComment->label(" Draw results of ethan preview ");
		btn_stsComment->redraw();
		Fl::flush();
		const Fl_Menu_Item *mi=ch_File->mvalue();
		box_Image->Preview((char *)mi->user_data(), 
				tout_EthanCfg->value(), 
				vout_Radius->value());
		btn_stsComment->label("");
		btn_stsComment->redraw();
	}else{
		fl_alert("Raduis is not set. Ethan cannot proceed.");
		o->value(0);
		return;
	}
}else box_Image->UnPreview();

box_Image->redraw();
box_Image->draw_overlay();
fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK, FL_WHITE);
Fl::flush();




//;
}

static unsigned char *image_prev[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"\"\"\"!!!!!!!!!!!!!",
(unsigned char*)
"!\"\"!!!\"\"!!!!!!!!!!!!",
(unsigned char*)
"!\"!!!!!\"!\"\"!!!!!!!!!",
(unsigned char*)
"!\"!!!!!\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!\"!!!!!\"!!!!\"\"!!!!!!",
(unsigned char*)
"!\"\"!!!\"\"!!!!!\"!!!!!!",
(unsigned char*)
"!!\"\"\"\"\"!!!!!!\"!!!!!!",
(unsigned char*)
"!!!!!!\"\"!!!!\"\"!!!!!!",
(unsigned char*)
"!!!!!!!\"!!!!\"!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"\"\"\"\"!!\"\"\"\"!",
(unsigned char*)
"!!!!!!!!!!!!!!\"\"!!\"\"",
(unsigned char*)
"!!!!!!!!!!\"\"!\"\"!!!!\"",
(unsigned char*)
"\"\"\"!!!!!\"\"\"\"\"\"!!!!!\"",
(unsigned char*)
"!!\"\"!!!\"\"!!!!\"!!!!!\"",
(unsigned char*)
"!!!\"\"!!\"!!!!!\"\"!!!\"!",
(unsigned char*)
"!!!!\"\"!\"\"!!!!!\"\"\"\"!!",
(unsigned char*)
"!!!!!\"!!\"\"!!!\"\"!!!!!",
(unsigned char*)
"!!!!!\"!!!\"\"\"\"\"!!!!!!"
};
static Fl_Pixmap pixmap_prev(image_prev);

Fl_Value_Output *vout_Box=(Fl_Value_Output *)0;

Fl_Value_Output *vout_Radius=(Fl_Value_Output *)0;

Fl_Button *btn_Return1=(Fl_Button *)0;

static void cb_btn_Return1(Fl_Button*, void*) {
  //vout_CurRadius->value(vout_Radius->value());
//vout_CurRadius->redraw();
//vout_CurBox->value(vout_Box->value());
//vout_CurBox->redraw();

if (treefoc==0){                                      // Only need to set radius if it isn't set yet.
	PrjInFile *n=(PrjInFile *)tree_Unproc->selected()->data();
	PrjGroup *gr=Groups;

	while ((gr!=NULL) && (strcmp(gr->grname, n->grname)!=0)) gr=gr->next;
	
	if  (strcmp(gr->grname,n->grname)==0){
//if (gr->groupno==n->groupno) {
		gr->radius=(int)vout_Radius->value();
		gr->box=(int)vout_Box->value();
		mprintf("   Setting values: virus radius: %d, box size: %d, for group: %s\n",
			gr->radius, gr->box, gr->grname);
	}
}

//fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK, FL_WHITE);
wnd_InspectUnproc->hide();
}

MicroGraphBox *box_Image=(MicroGraphBox *)0;

static void cb_gfx1(Fl_Button*, void*) {
  box_Image->Mmode(MarkArea);
}

static unsigned char *image_select[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!\"\"\"!!\"\"\"!!\"\"\"!!\"\"\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"\"\"!!\"\"\"!!\"\"\"!!\"\"\"!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_select(image_select);

static void cb_gfx2(Fl_Button*, void*) {
  box_Image->Mmode(ZoomIn);
btn_stsComment->label(" Box the area to zoom ");
btn_stsComment->redraw();
}

static unsigned char *image_zoomin[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!!\"\"!!!!\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"!!!\"!!!\"\"!!!!",
(unsigned char*)
"!!!!\"\"!!!!\"!!!!\"!!!!",
(unsigned char*)
"!!!!\"!!!!!\"!!!!\"\"!!!",
(unsigned char*)
"!!!!\"!!\"\"\"\"\"\"\"!!\"!!!",
(unsigned char*)
"!!!!\"!!!!!\"!!!!!\"!!!",
(unsigned char*)
"!!!!\"!!!!!\"!!!!\"\"!!!",
(unsigned char*)
"!!!!\"\"!!!!\"!!!!\"!!!!",
(unsigned char*)
"!!!!!\"\"\"!!!!!!\"\"!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!!!!!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"\"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_zoomin(image_zoomin);

static unsigned char *image_zoomout[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!!\"\"!!!!\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!!\"\"!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!!\"!!!!",
(unsigned char*)
"!!!!\"!!!!!!!!!!\"\"!!!",
(unsigned char*)
"!!!!\"!!\"\"\"\"\"\"\"!!\"!!!",
(unsigned char*)
"!!!!\"!!!!!!!!!!!\"!!!",
(unsigned char*)
"!!!!\"!!!!!!!!!!\"\"!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!!\"!!!!",
(unsigned char*)
"!!!!!\"\"\"!!!!!!\"\"!!!!",
(unsigned char*)
"!!!!!!\"\"\"!!!\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!!!!!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"\"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_zoomout(image_zoomout);

Fl_Button *btn_SetRadiusMode=(Fl_Button *)0;

static void cb_btn_SetRadiusMode(Fl_Button*, void*) {
  box_Image->Mmode(DrawCircle);
btn_stsComment->label(" Draw circles to identify optimal radius");
btn_stsComment->redraw();
}

static unsigned char *image_radius[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!\"\"!!!!!",
(unsigned char*)
"!!!!\"!!!!!!!!!!\"!!!!",
(unsigned char*)
"!!!\"!!!!\"\"\"\"!!!!\"!!!",
(unsigned char*)
"!!\"!!!\"\"!!!!\"\"!!!\"!!",
(unsigned char*)
"!!\"!!\"!!!!!!!!\"!!\"!!",
(unsigned char*)
"!\"!!!\"!!!\"\"!!!\"!!!\"!",
(unsigned char*)
"!\"!!\"!!!\"!!\"!!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!!\"!!\"!!!\"!!\"!",
(unsigned char*)
"!\"!!!\"!!!\"\"!!!\"!!!\"!",
(unsigned char*)
"!!\"!!\"!!!!!!!!\"!!\"!!",
(unsigned char*)
"!!\"!!!\"\"!!!!\"\"!!!\"!!",
(unsigned char*)
"!!!\"!!!!\"\"\"\"!!!!\"!!!",
(unsigned char*)
"!!!!\"!!!!!!!!!!\"!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!\"\"!!!!!",
(unsigned char*)
"!!!!!!!\"\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_radius(image_radius);

Fl_Button *btn_SetBoxMode=(Fl_Button *)0;

static void cb_btn_SetBoxMode(Fl_Button*, void*) {
  box_Image->Mmode(DrawBox);
btn_stsComment->label("Draw box to set box size for ethan ");
btn_stsComment->redraw();
}

static unsigned char *image_bsize[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!\"\"\"\"\"\"\"\"\"\"\"\"!!\"!",
(unsigned char*)
"!\"!!\"!!!!!!!!!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!!!!!!!!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"\"\"\"\"\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"!!!!\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!\"\"\"\"\"\"!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!!!!!!!!!\"!!\"!",
(unsigned char*)
"!\"!!\"!!!!!!!!!!\"!!\"!",
(unsigned char*)
"!\"!!\"\"\"\"\"\"\"\"\"\"\"\"!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"!!!!!!!!!!!!!!!!\"!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_bsize(image_bsize);

Fl_Window *wnd_Mosaic=(Fl_Window *)0;

Fl_Scroll *scrl_Mosaic=(Fl_Scroll *)0;

static void cb_scrl_Mosaic(Fl_Scroll*, void*) {
  printf("Scroller Callback is called!\n");
}

Fl_Group *scrl_test=(Fl_Group *)0;

Fl_Scroll *scrl_Delete=(Fl_Scroll *)0;

Fl_Group *grp_ProcStatus=(Fl_Group *)0;

static unsigned char *image_totop[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\330\334\330$\200\200\200%\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!\"###########$%!!!",
(unsigned char*)
"!!!\"#$$$$$$$$$$$%!!!",
(unsigned char*)
"!!!\"%%%%%%%%%%%%%!!!",
(unsigned char*)
"!!!!!!!!!\"%!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"%%!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"#$%!!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"!!%%!!!!!!!",
(unsigned char*)
"!!!!!!!\"#!!$%!!!!!!!",
(unsigned char*)
"!!!!!!\"\"!!!!%%!!!!!!",
(unsigned char*)
"!!!!!!\"#!!!!$%!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!%%!!!!!",
(unsigned char*)
"!!!!!\"#!!!!!!$%!!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!%%!!!!",
(unsigned char*)
"!!!!\"#!!!!!!!!$%!!!!",
(unsigned char*)
"!!!\"\"$$$$$$$$$$$%!!!",
(unsigned char*)
"!!!\"%%%%%%%%%%%%%!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_totop(image_totop);

static unsigned char *image_up[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\0\0\0$\330\334\330%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"##!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"$%#!!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"!!##!!!!!!!",
(unsigned char*)
"!!!!!!!\"$!!%#!!!!!!!",
(unsigned char*)
"!!!!!!\"\"!!!!##!!!!!!",
(unsigned char*)
"!!!!!!\"$!!!!%#!!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!##!!!!!",
(unsigned char*)
"!!!!!\"$!!!!!!%#!!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!##!!!!",
(unsigned char*)
"!!!!\"$!!!!!!!!%#!!!!",
(unsigned char*)
"!!!\"\"%%%%%%%%%%%#!!!",
(unsigned char*)
"!!!\"#############!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_up(image_up);

static unsigned char *image_down[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\0\0\0$\330\334\330%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"#!!!",
(unsigned char*)
"!!!\"\"$$$$$$$$$$%#!!!",
(unsigned char*)
"!!!!\"$!!!!!!!!%#!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!##!!!!",
(unsigned char*)
"!!!!!\"$!!!!!!%#!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!##!!!!!",
(unsigned char*)
"!!!!!!\"$!!!!%#!!!!!!",
(unsigned char*)
"!!!!!!\"\"$!!!##!!!!!!",
(unsigned char*)
"!!!!!!!\"$!!%#!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"!!##!!!!!!!",
(unsigned char*)
"!!!!!!!!\"$%#!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"##!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_down(image_down);

static unsigned char *image_tobottom[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\0\0\0$\330\334\330%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"#!!!",
(unsigned char*)
"!!!\"\"$$$$$$$$$$%#!!!",
(unsigned char*)
"!!!!\"$!!!!!!!!%#!!!!",
(unsigned char*)
"!!!!\"\"!!!!!!!!##!!!!",
(unsigned char*)
"!!!!!\"$!!!!!!%#!!!!!",
(unsigned char*)
"!!!!!\"\"!!!!!!##!!!!!",
(unsigned char*)
"!!!!!!\"$!!!!%#!!!!!!",
(unsigned char*)
"!!!!!!\"\"$!!!##!!!!!!",
(unsigned char*)
"!!!!!!!\"$!!%#!!!!!!!",
(unsigned char*)
"!!!!!!!\"\"!!##!!!!!!!",
(unsigned char*)
"!!!!!!!!\"$%#!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"##!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!\"$$$$$$$$$$$%#!!!",
(unsigned char*)
"!!!\"$%%%%%%%%%%%#!!!",
(unsigned char*)
"!!!\"#############!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_tobottom(image_tobottom);

static void cb_gfx3(Fl_Button*, void*) {
  int n=scrl_Mosaic->children();
int m=scrl_Delete->children();
int x=3, y=3, tx,ty;
//Fl_Button *w1,
Fl_Button *w;
PrjOutFile *ouf;

// first find how much space is taken up by the 
// buttons that are already in the delete scroller

//printf("Mosaic has %d children and delete has %d\n",n,m);

for(int i=0;i<m-2;i++){                      // delete seems to already have 2 children from the start
	if (x+VBSIZE+5>scrl_Delete->w()) {y+=(VBSIZE+5); x=3;}
	x+=(VBSIZE+5);
}

// move the down buttons from mosaic
// to delete window

for(int i=0;i<n;i++){
	w= (Fl_Button *)scrl_Mosaic->child(i);
	if (w->value()==1){
		w->value(0);		
		ouf=(PrjOutFile *)w->user_data();
		ouf->fordel=1;
		tx=w->x(); ty=w->y();
		scrl_Delete->add(w);
		if (x+VBSIZE+5>scrl_Delete->w()) {y+=(VBSIZE+5); x=3;}
		w->position(scrl_Delete->x() +x , scrl_Delete->y()+y);
		x+=(VBSIZE+5);
		i--;
		scrl_Mosaic->redraw();
	}
}

scrl_Mosaic->redraw();
scrl_Delete->redraw();
}

static unsigned char *image_forth[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\320\324\320$\210\210\210%\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"\"!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"##\"!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!#\"!!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!#\"!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!#\"!!!!",
(unsigned char*)
"!!\"\"\"\"\"\"\"\"#!!!!#\"!!!",
(unsigned char*)
"!!\"########!!!!!#\"!!",
(unsigned char*)
"!!\"#!!!!!!!!!!!!!#\"!",
(unsigned char*)
"!!\"#!!!!!!!!!!!!!!#\"",
(unsigned char*)
"!!\"#!!!!!!!!!!!!!!$%",
(unsigned char*)
"!!\"#!!!!!!!!!!!!!$%!",
(unsigned char*)
"!!\"$$$$$$$#!!!!!$%!!",
(unsigned char*)
"!!%%%%%%%\"#!!!!$%!!!",
(unsigned char*)
"!!!!!!!!!\"#!!!$%!!!!",
(unsigned char*)
"!!!!!!!!!\"#!!$%!!!!!",
(unsigned char*)
"!!!!!!!!!\"#!$%!!!!!!",
(unsigned char*)
"!!!!!!!!!\"!$%!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"%%!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_forth(image_forth);

static void cb_gfx4(Fl_Button*, void*) {
  //int n=scrl_Delete->children();
Fl_Button *w;
PrjOutFile *ouf;
//printf("Delete children :%d\n",n);

//while(i<scrl_Delete->children()-2){
for(int i=0;i<scrl_Delete->children()-2;i++){
	w= (Fl_Button *)scrl_Delete->child(i);
//	printf("Testing %d, userdata: %d \n ", i,w->user_data());
	if (w->value()==1){
		scrl_Delete->remove((Fl_Widget *)w);
		ouf=(PrjOutFile *)w->user_data();
		ouf->fordel=0;
		delete(w);
		i--;
	}
}

fnc_ClearMosaic();
fnc_FillMosaic(ch_mos_File->text());
scrl_Delete->redraw();
}

static unsigned char *image_back[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\320\324\320$\210\210\210%\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!\"#$%!!!!!!!!!",
(unsigned char*)
"!!!!!!\"#!$%!!!!!!!!!",
(unsigned char*)
"!!!!!\"#!!$%!!!!!!!!!",
(unsigned char*)
"!!!!\"#!!!$%!!!!!!!!!",
(unsigned char*)
"!!!\"#!!!!$%\"\"\"\"\"\"\"!!",
(unsigned char*)
"!!\"#!!!!!########%!!",
(unsigned char*)
"!\"#!!!!!!!!!!!!!$%!!",
(unsigned char*)
"\"#!!!!!!!!!!!!!!$%!!",
(unsigned char*)
"%$!!!!!!!!!!!!!!$%!!",
(unsigned char*)
"!%$!!!!!!!!!!!!!$%!!",
(unsigned char*)
"!!%$!!!!!$$$$$$$$%!!",
(unsigned char*)
"!!!%$!!!!$%%%%%%%%!!",
(unsigned char*)
"!!!!%$!!!$%!!!!!!!!!",
(unsigned char*)
"!!!!!%$!!$%!!!!!!!!!",
(unsigned char*)
"!!!!!!%$!$%!!!!!!!!!",
(unsigned char*)
"!!!!!!!%$$%!!!!!!!!!",
(unsigned char*)
"!!!!!!!!%%%!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_back(image_back);

static void cb_Delete(Fl_Button*, void*) {
  Fl_Button *b;
PrjOutFile *ouf, *ouf1, *next;
char *buf=new char[NAMESIZE];
char *oname=new char[200];
char *nname=new char[200];


while (scrl_Delete->children()>2){
	ouf1=OutFiles;						   // ouf1 if the head of the list
	b   = (Fl_Button *)scrl_Delete->child(0);
	ouf = (PrjOutFile *)b->user_data();		 // ouf is the file being deleted 
//	while (ouf1->next) ouf1=ouf1->next;            // find last outfile in the list
	strcpy(buf,ouf->oufname);			     // save the file name;
	next=ouf->next;						   // save next pointer
	memcpy(ouf,ouf1, sizeof(PrjOutFile));		// copy last outfile over deleted
	strcpy(ouf->oufname, buf);                           // restore filename 
	ouf->next = next;					  //

	sprintf(oname, "%s%s",tout_ProjDir->value() ,ouf1->oufname);
	sprintf(nname, "%s%s",tout_ProjDir->value() ,buf);
//	printf("Overwriting nname:%s \n       with oname:%s\n", nname,oname);
	rename(oname,nname);                                 // possibly add erorr checking here 
	
//	printf("current Outfiles :%s  %d", OutFiles->oufname,OutFiles);
//	printf("next Outfiles :%s", OutFiles->next->oufname);
//	printf("  next ouf1 :%s\n", ouf1->oufname);
	OutFiles=ouf1->next;
	delete(ouf1);

	scrl_Delete->remove(b);
	delete(b);
}

scrl_Delete->redraw();
}

Fl_Group *grp_FileControl=(Fl_Group *)0;

Fl_Choice *ch_mos_Group=(Fl_Choice *)0;

Fl_Choice *ch_mos_File=(Fl_Choice *)0;

static void cb_ch_mos_File(Fl_Choice* o, void*) {
  fnc_ClearMosaic();
fnc_FillMosaic(o->text());
}

Fl_Button *btn_NextProcFile=(Fl_Button *)0;

static unsigned char *image_next[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\330\334\330$\200\200\200%\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"##\"\"\"!!!!!!!!!!!",
(unsigned char*)
"!!!\"#!!#\"\"\"!!!!!!!!!",
(unsigned char*)
"!!!\"#!!!!#\"\"\"!!!!!!!",
(unsigned char*)
"!!!\"#!!!!!!#\"\"\"!!!!!",
(unsigned char*)
"!!!\"#!!!!!!!!#\"\"\"!!!",
(unsigned char*)
"!!!\"#!!!!!!!!$%%%!!!",
(unsigned char*)
"!!!\"#!!!!!!$%%%!!!!!",
(unsigned char*)
"!!!\"#!!!!$%%%!!!!!!!",
(unsigned char*)
"!!!\"#!!$%%%!!!!!!!!!",
(unsigned char*)
"!!!\"#$%%%!!!!!!!!!!!",
(unsigned char*)
"!!!\"$%%!!!!!!!!!!!!!",
(unsigned char*)
"!!!%%!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_next(image_next);

Fl_Button *btn_PrevProcFile=(Fl_Button *)0;

static unsigned char *image_previ[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\0\0\0$\330\334\330%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!\"\"!!!",
(unsigned char*)
"!!!!!!!!!!!!!\"\"\"#!!!",
(unsigned char*)
"!!!!!!!!!!!\"\"\"$%#!!!",
(unsigned char*)
"!!!!!!!!!\"\"\"$!!%#!!!",
(unsigned char*)
"!!!!!!!\"\"\"$!!!!%#!!!",
(unsigned char*)
"!!!!!\"\"\"$!!!!!!%#!!!",
(unsigned char*)
"!!!\"\"\"$!!!!!!!!%#!!!",
(unsigned char*)
"!!!###%!!!!!!!!%#!!!",
(unsigned char*)
"!!!!!###%!!!!!!%#!!!",
(unsigned char*)
"!!!!!!!###%!!!!%#!!!",
(unsigned char*)
"!!!!!!!!!###%!!%#!!!",
(unsigned char*)
"!!!!!!!!!!!###%%#!!!",
(unsigned char*)
"!!!!!!!!!!!!!##%#!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!##!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_previ(image_previ);

Fl_Button *btn_FirstProcFile=(Fl_Button *)0;

static unsigned char *image_first[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\330\334\330$\0\0\0%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!\"\"\"\"!!!!!!!!!!!\"\"!!",
(unsigned char*)
"!\"##$!!!!!!!!!\"\"\"$!!",
(unsigned char*)
"!\"#%$!!!!!!!\"\"\"#%$!!",
(unsigned char*)
"!\"#%$!!!!!\"\"\"#!!%$!!",
(unsigned char*)
"!\"#%$!!!\"\"\"#!!!!%$!!",
(unsigned char*)
"!\"#%$!\"\"\"#!!!!!!%$!!",
(unsigned char*)
"!\"#%$\"\"#!!!!!!!!%$!!",
(unsigned char*)
"!\"#%$$$%!!!!!!!!%$!!",
(unsigned char*)
"!\"#%$!$$$%!!!!!!%$!!",
(unsigned char*)
"!\"#%$!!!$$$%!!!!%$!!",
(unsigned char*)
"!\"#%$!!!!!$$$%!!%$!!",
(unsigned char*)
"!\"#%$!!!!!!!$$$%%$!!",
(unsigned char*)
"!\"%%$!!!!!!!!!$$%$!!",
(unsigned char*)
"!\"$$$!!!!!!!!!!!$$!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_first(image_first);

Fl_Button *btn_LastProcFile=(Fl_Button *)0;

static unsigned char *image_last[] = {
(unsigned char*)
"20 20 -5 1",
(unsigned char*)
"!\300\300\300\"\370\374\370#\330\334\330$\0\0\0%\200\200\200",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"\"!!!!!!!!!!!\"\"\"\"!",
(unsigned char*)
"!!\"\"\"\"!!!!!!!!!\"##$!",
(unsigned char*)
"!!\"##\"\"\"!!!!!!!\"#%$!",
(unsigned char*)
"!!\"#!!#\"\"\"!!!!!\"#%$!",
(unsigned char*)
"!!\"#!!!!#\"\"\"!!!\"#%$!",
(unsigned char*)
"!!\"#!!!!!!#\"\"\"!\"#%$!",
(unsigned char*)
"!!\"#!!!!!!!!#\"\"\"#%$!",
(unsigned char*)
"!!\"#!!!!!!!!%$$\"#%$!",
(unsigned char*)
"!!\"#!!!!!!%$$$!\"#%$!",
(unsigned char*)
"!!\"#!!!!%$$$!!!\"#%$!",
(unsigned char*)
"!!\"#!!%$$$!!!!!\"#%$!",
(unsigned char*)
"!!\"#%$$$!!!!!!!\"#%$!",
(unsigned char*)
"!!\"%$$!!!!!!!!!\"%%$!",
(unsigned char*)
"!!$$!!!!!!!!!!!$$$$!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_last(image_last);

Fl_Button *btn_Return2=(Fl_Button *)0;

static void cb_btn_Return2(Fl_Button*, void*) {
  wnd_Mosaic->hide();
}

Fl_Window *wnd_MapOps=(Fl_Window *)0;

static void cb_Cancel1(Fl_Button*, void*) {
  wnd_MapOps->hide();
}

static void cb_Apply(Fl_Button*, void*) {
  wnd_MapOps->hide();
}

Fl_Window *wnd_ProcessProgress=(Fl_Window *)0;

Fl_Button *btn_ProgressRep=(Fl_Button *)0;

Fl_Window *wnd_SelectFiles=(Fl_Window *)0;

Fl_Browser *brws_MRCfiles=(Fl_Browser *)0;

static void cb_Select(Fl_Button*, void*) {
  int i=brws_MRCfiles->size();

while (i) brws_MRCfiles->select(i--);



//brws_MRCfiles->item_select(1, brws_MRCfiles->size());
//brws_MRCfiles->select(2,5);//brws_MRCfiles->size());
//brws_MRCfiles->redraw();
printf("Number of lines: %d\n",brws_MRCfiles->size() );
}

static void cb_Cancel2(Fl_Button*, void*) {
  wnd_SelectFiles->hide();;
}

static void cb_OK1(Fl_Button*, void*) {
  //char *lab;
PrjInFile *inf, *inf1;
PrjGroup *gr;
int i= brws_MRCfiles->size()+1;
//Fl_TreeNode node=tree_Unproc->selected();

//tree_Unproc->current(tree_Unproc->selected());
gr=(PrjGroup *)(tree_Unproc->selected()->data());

while (i--)
	if (brws_MRCfiles->selected(i)){
	inf = new PrjInFile();
	strcpy(inf->infname, brws_MRCfiles->text(i));	
	strcpy(inf->grname, gr->grname);
	strcpy(inf->infpath,tout_MRCDir->value()); 

	inf->tag=INPUT_FILE;	inf->next=NULL;

	if (!InFiles) InFiles=inf;
	else{
		inf1=InFiles;
		while (inf1->next) inf1 = inf1->next;
		inf1->next=inf;
	}
	
	tree_Unproc->current(tree_Unproc->selected());
	char *tmp=strdup (brws_MRCfiles->text(i));
	tree_Unproc->add_sub(tmp,0,NULL,inf);			
	mprintf(" Added file: %s to group %s \n", inf->infname, inf->grname); 	// Log transaction
}

wnd_SelectFiles->hide();


/*
tree_Unproc->current(tree_Unproc->selected());
if (p){
   // tree_Unproc->add_sub(p,0);
   //  Have to leave the name of the file only, no path
   //  for fltk doesn't like '/' characters.
   //   sprintf(WinName, "%s",p);

	for(i=strlen(p); i>0;i--)
		if (p[i]=='/'){ lab=strdup(p+i+1);  break; }   
//=====================================================
//  Add file to the lists

	gr=(PrjGroup *)(tree_Unproc->selected()->data());
	inf = new PrjInFile();
	strcpy(inf->infname, lab);
	inf->tag=INPUT_FILE;
	strcpy(inf->grname, gr->grname);
//	printf(" added ; %s to group: %s\n", inf->infname, inf->grname);
//	inf->groupno=gr->groupno;
	InFileNo++;
	inf->infileno=InFileNo;
	inf->next=NULL;

	if (!InFiles) InFiles=inf;
	else{
		inf1=InFiles;
		while (inf1->next) inf1 = inf1->next;
		inf1->next=inf;
	}

//  Add file to the tree
	tree_Unproc->add_sub(p+i+1,0,NULL,inf);	
// Log transaction
	mprintf(" Added file: %s to group %s \n", inf->infname, inf->grname);
}


*/;
}

Fl_Window *wnd_EthanCFG=(Fl_Window *)0;

Fl_Value_Input *vin_EthanParHeight=(Fl_Value_Input *)0;

Fl_Value_Input *vin_EthanParWidth=(Fl_Value_Input *)0;

Fl_Value_Input *vin_EthanParRWidth=(Fl_Value_Input *)0;

Fl_Value_Input *vin_EthanParDist=(Fl_Value_Input *)0;

Fl_Value_Input *vin_EthanParReduct=(Fl_Value_Input *)0;

Fl_Check_Button *chb_EthanParResIm=(Fl_Check_Button *)0;

Fl_Check_Button *chb_EthanParRefine=(Fl_Check_Button *)0;

Fl_Check_Button *chb_EthanTestSector=(Fl_Check_Button *)0;

Fl_Check_Button *chb_EthanTestHeight=(Fl_Check_Button *)0;

Fl_Check_Button *chb_EthanTestDistance=(Fl_Check_Button *)0;

static void cb_Apply1(Fl_Button*, void*) {
  fnc_WriteEthanCFG("/tmp/ethan.cfg");
tout_EthanCfg->value("/tmp/ethan.cfg");
wnd_EthanCFG->hide();
}

static void cb_Default(Fl_Button*, void*) {
  fnc_ClearEthanCFG();
tout_EthanCfg->value("");
wnd_EthanCFG->redraw();
}

Fl_Window *wnd_About=(Fl_Window *)0;

static void cb_OK2(Fl_Button*, void*) {
  wnd_About->hide();
}

Fl_Window *wnd_Project=(Fl_Window *)0;

static void cb_wnd_Project(Fl_Window*, void*) {
  exit (0);
}

Fl_Group *grp_DirSettings=(Fl_Group *)0;

Fl_Output *tout_ProjDir=(Fl_Output *)0;

Fl_Output *tout_MRCDir=(Fl_Output *)0;

Fl_Button *btn_SetPrjDir=(Fl_Button *)0;

static void cb_btn_SetPrjDir(Fl_Button*, void*) {
  const char *pp=tout_ProjDir->value();
char *m,*p = fl_file_chooser("Select Project directory","*",pp);

if (p){ 
	int mode=fnc_IsDir(p);
	if (mode&1){ 
		if (mode&2) {
			if(p[strlen(p)-1]!='/'){
				m=new char[strlen(p)+2];
				strcpy(m,p);
				strcat(m,"/");
				p=m;
			}
			tout_ProjDir->value(p); // writable
			CheckSave=1;
			if ((chb_Autosave->value()==0)  && (strcmp( tin_Name->value(),"")==0)) {
				btn_PrjSave->activate();
				btn_PrjSave->redraw();
			} 
		}
		else  fl_alert("\"%s\" \nis not open for writing.",p);
	}else fl_alert("\"%s\" \nis not a directory.",p);
};
}

static void cb_Browse(Fl_Button*, void*) {
  const char *pp=tout_MRCDir->value();
char *m, *p = fl_file_chooser("Select MRC directory","*",pp);
//if (p){
//	if (fnc_IsDir(p)==2) tout_MRCDir->value(p);  //readable
//	else fl_alert("\"%s\" \nis either not a directory or not open for reading",p);
//}

if (p){ 
	int mode=fnc_IsDir(p);
	if (mode&1){ 
		if (mode&4){
			if(p[strlen(p)-1]!='/'){
				m=new char[strlen(p)+2];
				strcpy(m,p);
				strcat(m,"/");
				p=m;
			} tout_MRCDir->value(p);   // readable
			CheckSave=1;
//+++++++++++++++++++++++++++++++
// this block may have to go away
			if ((chb_Autosave->value()==0)  && (strcmp( tin_Name->value(),"")==0)) {
				btn_PrjSave->activate();
				btn_PrjSave->redraw();
			}
//+++++++++++++++++++++++++++++++
		}else  fl_alert("\"%s\" \nis not open for reading.",p);
	}else fl_alert("\"%s\" \nis not a directory.",p);
};
}

Fl_Group *grp_FileSettings=(Fl_Group *)0;

Fl_Group *grp_ProcUnproc=(Fl_Group *)0;

Fl_Button *btn_Process=(Fl_Button *)0;

static void cb_btn_Process(Fl_Button*, void*) {
  int i=0, a=0, ethanstart=1, ethancheck=1;
PrjInFile *inf;
PrjOutFile *ouf =NULL;
PrjGroup *gr;
char tmp[200];
char tmp1[200];
char tmp2[200], buf[50];

memset(buf,0,50);


if  ((chb_Autosave->value()==1) && (strcmp(tin_Name->value(),"")==0)){
   fl_alert("  SPADE needs to save project, please \n supply a project name and try again.");
   return;
}

//Check if group is empty

Fl_ToggleNode *node=tree_Unproc->selected();
Fl_ToggleNode *groupnode=node;
inf=InFiles;
i=0;
while (inf){
	if (strcmp(inf->grname,node->label())==0){
		i=1; break;
	}
	inf=inf->next;	
}
if (i==0){
	fl_alert("  Cannot process empty group.");
	return;
}

//==================================================================
//    Check of box and radius values are set

if  ((vout_CurRadius->value()==0) || (vout_CurBox->value()==0)){
   fl_alert("Values of radius and/or Box size are not set. \n Without them ethan cannot run.");
   return;
}


//=========================================================
//	Check of box is at least 2 time the radius

if ((vout_CurRadius->value()*2) > vout_CurBox->value()){
	fl_alert("Box size must be at least twice the radius"); 
	return;
}

mprintf(" Processing group %s\n",node->label());
tree_Proc->add_next(node->label(),1,NULL,node->data());
gr=(PrjGroup *)node->data();
gr->processed=1;

tree_Unproc->traverse_start(tree_Unproc->selected());    // Set current to selected
tree_Unproc->traverse_forward();			 // Step next to the first file for processing	

getwd(tmp1);
inf=(PrjInFile *)tree_Unproc->current()->data();         // Get first In file
sprintf(tmp2,"%s%s",tout_ProjDir->value(),inf->grname);  // Create new directory for the group
mkdir(tmp2,S_IRWXU);				         //	

fl_cursor(FL_CURSOR_WAIT,FL_BLACK,FL_WHITE);		 // Change cursor
while((tree_Unproc->current()) && (!tree_Unproc->current()->can_open()) ){

//==========================================
//  Processing is here
//  Stepping down in the tree until there is no next item, or 
//  next item is a group

	char cmd[500];
	char *ch=tree_Unproc->current()->label();			// get infile name

	sprintf(cmd, "ethan %d %s%s %s%s/%s.points %s%s %d %d %s",	// Build ethan command string
		(int)vout_CurRadius->value(),  inf->infpath,ch,                               // radius, source file with path
		tout_ProjDir->value(),inf->grname ,ch,  tout_ProjDir->value(), inf->grname,      // projdir+ source file, projdir+group directory
		(int)vout_CurBox->value(), 	  ethanstart, tout_EthanCfg->value());  // box size, number of first output file, path to config file
	ethancheck= ethanstart;
													// attempt to create progress bar	
	Fl::flush();
	system(cmd);										// call ethan

//===========================================
// find all mrcs

	dirent *d;
	inf= (PrjInFile *) tree_Unproc->current()->data();
	DIR *dir=opendir(tmp2);
	d=readdir(dir);                                              // there is always "." directory 
	d=readdir(dir);                                              // there is always ".." directory there (except the root i guess)
	d=readdir(dir);


	while(d){	// if it's there and it's mrc										      // For all files in the firectory
	   if (!strncmp ( &((d->d_name)[strlen (d->d_name)-4]),".mrc",4)){
//		printf(" found %s \n",d->d_name);
		strncpy(buf, &(d->d_name[2]), 5);				// Extract digits from filename
		if(ethancheck <= atoi(buf)){                                    // Skip all files produced from prevous infiles
			ouf=new PrjOutFile();
			ouf->fordel=0;
			ouf->tag=OUTPUT_FILE;
			sprintf(tmp,"%s/%s",inf->grname,d->d_name);
			strcpy(ouf->oufname, tmp);				// set outfile name
			strcpy(ouf->infname, tree_Unproc->current()->label());  // set infile name fro outfile
			strcpy(ouf->grname, tree_Unproc->selected()->label());  // set groupname for out file
			ouf->next=OutFiles;					// Hookup to linked list
			OutFiles=ouf;
			ethanstart++;						// increment ethan start for next infile
		}
	    }
	    d=readdir(dir);	
              						// fetch next file
	}
	closedir(dir);
	mprintf("    Ethan has written %d output files from %s\n",ethanstart-ethancheck, ouf->infname);
	node=tree_Unproc->current();

	if (a==0){
		printf(" This tree node had userdata: %s\n",tree_Unproc->current()->label());
		printf("infname: %s, infpath: %s \n", inf->infname,inf->infpath);
		tree_Proc->add_sub(tree_Unproc->current()->label(),0,NULL,inf);
		Fl::flush();
		a=1;
	} else{
  		tree_Proc->add_next(tree_Unproc->current()->label(),0,NULL,inf);
		printf("adding tree node, no userdata, %s\n",tree_Unproc->current()->label());
		printf("infname: %s, infpath: %s \n", inf->infname,inf->infpath);

	}

	tree_Unproc->traverse_forward();
	tree_Unproc->remove(node);
}

//chdir(tmp1);
mprintf(" Processing complete.\n");
ouf=OutFiles;
// wnd_ProcessProgress->hide();
tree_Unproc->remove(groupnode);
scrl_UnpTree->damage(FL_DAMAGE_CHILD);
scrl_UnpTree->redraw();
Fl::wait(0);
fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK, FL_WHITE);

if (chb_Autosave->value()==0) {
	CheckSave=1;
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
} else btn_PrjSave->do_callback();

	vout_CurRadius->deactivate();
	vout_CurBox->deactivate();
	tree_Unproc->unselect();
	tree_Unproc->redraw();
	btn_Process->deactivate();
	btn_AddFile->deactivate();         
	btn_AddGroup->activate();         
	btn_RemFile->deactivate();


//+++;
}

Fl_Button *btn_RemGroup=(Fl_Button *)0;

static void cb_btn_RemGroup(Fl_Button* o, void*) {
  //brw_Unproc->remove(brw_Unproc->value());
PrjGroup *gr, *gr1=Groups;
PrjInFile *inf=InFiles, *inf1 = InFiles;
PrjOutFile *ouf=OutFiles, *ouf1=OutFiles;
//Fl_ToggleNode * node=tree_Unproc->selected();
Fl_ToggleTree *tree;
char *tmp=new char[200];

//gr=(PrjGroup *)node->data();	    // Get the group structure.
//printf("Group To be deleted: %s\n",gr->grname);
if (treefoc==1){
	gr=(PrjGroup *)tree_Proc->selected()->data();
	if (fl_ask("  Deleting group: %s \n  This action will remove processed files. \n  Proceed?",gr->grname)==0)
		return;
	tree=tree_Proc;
//	printf("removing with files!\n");
}else{
	gr=(PrjGroup *)tree_Unproc->selected()->data();
	tree=tree_Unproc;
//	printf("removing with no  files!\n");
}

//====================================================
//                 Remove any infiles that belong to the group

while(inf)					    // Check all infiles
	if (strcmp(inf->grname,gr->grname)==0){
		sprintf(tmp,"%s%s/%s.points",tout_ProjDir->value(),inf->grname,inf->infname);
		unlink(tmp);
//		printf("Deleting: %s: %d\n",tmp,unlink(tmp));
		if(inf==InFiles){
			InFiles=InFiles->next;
			delete(inf);
			inf=InFiles;
		}else{
			inf1=InFiles;
			while(inf1->next!=inf) inf1=inf1->next;
			inf1->next=inf->next;
			delete(inf);
			inf=inf1->next;
		}
}else inf=inf->next;

//=======================================================
//                        Remove any output files that belong to the group
 
while(ouf)					    //
//	printf("Going through outfiles: comparing [%s] and [%s]\n",ouf->grname,gr->grname);
	if (strcmp(ouf->grname,gr->grname)==0){
		if(ouf==OutFiles){
			OutFiles=OutFiles->next;
			sprintf(tmp,"%s%s",tout_ProjDir->value(),ouf->oufname);
			unlink(tmp);
//			printf("Unlinking: %s\n ",tmp);
			delete(ouf);
			ouf=OutFiles;
		}else{
			ouf1=OutFiles;
			while(ouf1->next!=ouf) ouf1=ouf1->next;
			ouf1->next=ouf->next;
			sprintf(tmp,"%s%s",tout_ProjDir->value(),ouf->oufname);
			unlink(tmp);
//			printf("Unlinking: %s\n ",tmp);
			delete(ouf);
			ouf=ouf1->next;
		}
}else ouf=ouf->next;

sprintf(tmp,"%s%s",tout_ProjDir->value(),gr->grname);
//if (rmdir(tmp)) printf("Directory removed sucessfully.\n");
rmdir(tmp);
//=================================================
//                              Remove the group itself

if (gr1==gr) Groups=Groups->next;
else{
	while(gr1->next!=gr)gr1=gr1->next;
	gr1->next=gr->next;
}
mprintf(" Deleting group: %s, with all files \n",gr->grname);
delete(gr);

tree->remove(tree->selected());
tree->redraw();
scrl_UnpTree->redraw();
scrl_procTree->redraw();
if (!tree->selected()) o->deactivate();

CheckSave=1;
//+++++++++++++++++++++++++
// set for deletion
if (chb_Autosave->value()==0) {
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
} 
//++++++++++++++++++++++++++++++++
//;
}

static unsigned char *image_sub[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_sub(image_sub);

Fl_Button *btn_InspWnd=(Fl_Button *)0;

static void cb_btn_InspWnd(Fl_Button*, void*) {
  //


Fl_ToggleNode *n; 
//Fl_Node *no;

char path[200];  
Fl_ToggleTree *ttree;
PrjGroup *gr=Groups;
PrjInFile *inf;

if (treefoc==0){ 					              // not processed yet file
	ttree=tree_Unproc;
//	printf("Unproc branch! %d\n",n);
	vout_Radius->activate();
	vout_Box->activate();
	btn_SetRadiusMode->activate();         			 // Activate buttons for mouse
	btn_SetBoxMode->activate();                    		   // modes in microg window
	inf=(PrjInFile *)(ttree->selected()->data());		// Get file selecetd for viewing from tree
	while (strcmp(gr->grname, inf->grname)!=0) 	   // Find the group from which it came
		gr=gr->next;
//	printf(" Group name: %s, radius %d, box %d\n",gr->grname, gr->radius, gr->box);
	vout_Radius->value(gr->radius );			 // Set value for box and radius
	vout_Box->value(gr->box );				    // in microg value_outs
}else{										    // Processed file
	ttree=tree_Proc;
	inf=(PrjInFile *)(ttree->selected()->data());
	printf("inf %p\n",(ttree->selected()->data()));
//	printf("%s%s\n", inf->infpath, n->label());
	ttree->traverse_start(ttree->selected());
	ttree->traverse_up();
	gr=(PrjGroup *)ttree->current()->data();
	vout_Radius->value(gr->radius);
	vout_Radius->deactivate();
	vout_Box->value(gr->box);
	vout_Box->deactivate();
	btn_SetRadiusMode->deactivate();
	btn_SetBoxMode->deactivate();
}

n=ttree->selected();
//!!!!
//sprintf(path,"%s%s", tout_MRCDir->value(), n->label());
//printf("n->label: %s, inf-> %d\n",n->label(),inf);
sprintf(path,"%s%s", inf->infpath,inf->infname);

// printf(" Opening micrograph : [%s]\n",path);
Fileimage *im=new Fileimage(path);

int th=im->ySize();
// , ratio=0, bwidth=0;                     // Get image size
int tw=im->xSize();

fl_cursor(FL_CURSOR_WAIT, FL_BLACK,FL_WHITE);
Fl::flush();
double d=box_Image->Redisplay(im,0,0,tw,th);	  //make suitable pixelmap
box_Image->FileImage(im);
vout_Zoom->value(d);

Fl_ToggleNode *node = ttree->traverse_start();
int nn=0;
	while (node){             			  // Copy all groups to the Microgarph viewing window
							  // have to clear the fl_chooser first
		if (node->can_open())                     //  If this node is a group add it to list of groups
			nn=ch_Group->add(node->label());  //  set nn as index to last group added
		else{ 					  //   if node is not a group (infile),
			if (node==ttree->selected()) 	  //  check if it's selected
				ch_Group->value(nn);      //  if so, then set this group as current (active)
		}									
		node=ttree->traverse_forward();
	}						  // quite wicked code, but logic is correct. 
char *tmp=NULL;        

ch_File->clear();
node=ttree->find((char *)(ch_Group->text()));
node=ttree->traverse_forward();        			  // Copy list of files in a current group 

	while (node && !node->can_open()){                // To microgarph window to the file choise widget
		tmp=(char *) malloc(200);
		sprintf(tmp,"%s%s",tout_MRCDir->value(), node->label());
		nn=ch_File->add(node->label(),NULL,NULL,strdup(tmp));
		//printf("Files added to selection: %s \n", tmp);
		if (node==ttree->selected()) ch_File->value(nn);	
//		printf("label: [%s], data: [%s]\n",node->label(), (ch_File->menu())[nn].user_data_);
		node=ttree->traverse_forward();
	}						   // Label conatins a file name, data has full path and
							   // the file name	

if (treefoc==1){
// find the group!
	sprintf(tmp,"%s%s/%s.points",tout_ProjDir->value(),ch_Group->text(),n->label());
//	printf("Center file: %s, %d\n", tmp,fnc_FileExists(tmp));
	box_Image->SetCApath(tmp);
	btn_EthanPrev->set();
	btn_EthanPrev->do_callback();
//	btn_EthanPrev->deactivate();
        box_Image->redraw_overlay(); 
}else {
	btn_EthanPrev->value(0);
//	btn_EthanPrev->activate();	
}

wnd_InspectUnproc->show();

//box_Image->SetWidgetRadius(vout_Radius);
//box_Image->SetWidgetBoxSize(vout_Box);
//box_Image->SetWidgetZoom(vout_Zoom);

box_Image->show();
box_Image->redraw();
fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK,FL_WHITE);
Fl::flush();

//;
}

static unsigned char *image_eye[] = {
(unsigned char*)
"20 20 -4 1",
(unsigned char*)
"!\300\300\300\"\0\0\0#\370\374\370$\0\0\370",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"\"\"!!!!!!!",
(unsigned char*)
"!!!!!!\"\"\"\"\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"\"!####!\"\"\"!!!",
(unsigned char*)
"!!!!\"\"\"!#$$$$##!\"\"!!",
(unsigned char*)
"!!!\"\"\"!#$$$$$$##!\"\"!",
(unsigned char*)
"!!\"\"\"!##$$\"\"$$###!\"\"",
(unsigned char*)
"\"\"\"\"\"!##$$\"\"#$###!\"\"",
(unsigned char*)
"!\"\"\"!!##$$$#$$##!\"\"!",
(unsigned char*)
"!!\"\"\"!###$$$$##!\"\"!!",
(unsigned char*)
"!!!!\"\"!#######!\"\"!!!",
(unsigned char*)
"!!!!!\"\"\"!###!\"\"\"!!!!",
(unsigned char*)
"!!!!!!!!\"\"\"\"\"\"!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_eye(image_eye);

Fl_Group *grp_UnprocBtns=(Fl_Group *)0;

Fl_Button *btn_AddFile=(Fl_Button *)0;

static void cb_btn_AddFile(Fl_Button*, void*) {
  //
DIR *mdir=opendir(tout_MRCDir->value());
dirent *mfile;

brws_MRCfiles->clear();
while((mfile=readdir(mdir))!=NULL){
	if ((strcmp(&(mfile->d_name[strlen(mfile->d_name)-4]), ".mrc")==0)
	   ||(strcmp(&(mfile->d_name[strlen(mfile->d_name)-4]), ".pgm")==0))
          brws_MRCfiles->add(mfile->d_name);
}
wnd_SelectFiles->show();

CheckSave=1;
//++++++++++++++++++++++++++
// set for deletion
if ((chb_Autosave->value()==0)  && (strcmp( tin_Name->value(),"")==0)) {
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
} 
//++++++++++++++++++++++++++++




//;
}

static unsigned char *image_adds[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_adds(image_adds);

Fl_Button *btn_RemFile=(Fl_Button *)0;

static void cb_btn_RemFile(Fl_Button*, void*) {
  PrjInFile *inf, *inf1=InFiles;

if (tree_Unproc->selected()){
 	inf=(PrjInFile *) tree_Unproc->selected()->data();
	mprintf(" Deleting in file: %s \n", inf->infname);
	if (inf1==inf){                                                    // if deleting first input file
		InFiles=inf->next;				     // Set InFiles pointer to the next one
		delete(inf);						   // Delete
	} else{
		while (inf1->next!=inf) inf1=inf1->next;  // Find the node being deleted
//!!!		while (inf1->next==inf) inf1=inf1->next;  // Find the node being deleted
		inf1->next=inf->next;				   // Redirect link
		delete(inf);
	}
	tree_Unproc->remove(tree_Unproc->selected());
}

CheckSave=1;
//++++++++++++++++++++++++++++++++++++++
// set for deletion

if (chb_Autosave->value()==0) {
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
} 
//++++++++++++++++++++++++++++++++++++++


// deleteion from the lists should be implemented!!!;
}

static unsigned char *image_subs[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!\"\"\"\"\"\"\"\"\"\"!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_subs(image_subs);

Fl_Button *btn_AddGroup=(Fl_Button *)0;

static void cb_btn_AddGroup(Fl_Button*, void*) {
  //char *p = fl_file_chooser("Pick a file","*.mrc","");
//brw_Unproc->add(p,NULL);
//tin_GroupName->value("");
//wnd_NewGroup->show();


const char *ch=fl_input("New Group Name: ");
//=================================================
//        Update internal data structure
if ((ch) && (strcmp(ch,"")!=0)){
PrjGroup *gr=Groups;
int n=0;
Fl_ToggleNode *nn;

while (gr) {
	if (strcmp(ch, gr->grname)==0){
		n=1;
		break;
	}
	gr=gr->next;
}

if (n==0){
	gr= new PrjGroup();
	GroupNo++;
	gr->tag=GROUP;
	strcpy(gr->grname, ch);
	gr->groupno=GroupNo;
	gr->processed=0;
	gr->next=Groups;
	gr->radius=0;
	gr->box=0;
	Groups=gr;

//         Udate the tree widget

	tree_Unproc->traverse_start();
	char *tmp = strdup(ch);
	nn=tree_Unproc->add_next( tmp, 1, NULL, gr);
//	printf(" Selection before unselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->unselect();
//	printf(" Selection after unselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->select_range(nn,nn);
//	printf(" Selection after unselect, after rangeselect: %d \n ", tree_Unproc->selected());
	tree_Unproc->traverse_start(nn);
//	printf(" Selection after traverse: %d \n ", tree_Unproc->selected());
//	tree_Unproc->select(nn);
	tree_Proc->unselect();
	
//	if(tree_Unproc->selected()) printf("Node selected\n"); else printf("Not selsected!\n");
	tree_Unproc->do_callback();
//	wnd_NewGroup->hide();

// 	Logging group creation
	mprintf(" Added new group: %s\n", gr->grname);
	CheckSave=1;
	if (chb_Autosave->value()==0) {
		btn_PrjSave->activate();
		btn_PrjSave->redraw();
	} 
} else 
   fl_alert(" Group \"%s\" already exists. ",  tin_GroupName->value());


}
//;
}

static unsigned char *image_add[] = {
(unsigned char*)
"20 20 -2 1",
(unsigned char*)
"!\300\300\300\"\0\0\0",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!\"\"\"\"\"\"\"\"\"\"\"\"\"\"!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!\"\"!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_add(image_add);

Fl_Scroll *scrl_UnpTree=(Fl_Scroll *)0;

Fl_ToggleTree *tree_Unproc=(Fl_ToggleTree *)0;

static void cb_tree_Unproc(Fl_ToggleTree* o, void*) {
  Fl_ToggleNode *node=o->selected();

if (node){
	tree_Proc->unselect();
	tree_Proc->redraw();
	btn_InspProcWnd->deactivate();	
	btn_AddGroup->activate();
	treefoc=0;

	if (node->can_open()){                     // a groups
		btn_AddFile->activate();          // new file can be added to a group
		btn_RemGroup->activate();     //  a group can be removed 
		btn_Process->activate();         //  a group can be processed

		btn_RemFile->deactivate();      // a file cannot be removed without specifing which
		btn_InspWnd->deactivate();    // an unprocessed group cannot be viewed as micrograph

		PrjGroup *gr= (PrjGroup *)node->data();    // show values of radius and box size
		vout_CurRadius->value(gr->radius);          //  in the tabs
		vout_CurBox->value(gr->box);
		vout_CurRadius->activate();
		vout_CurBox->activate();

//		printf("Values: %d, %d\n",gr->radius,gr->box);
	} else {  						//  Single file
		btn_AddFile->deactivate();	 //  New file cannot be added
		btn_RemGroup->deactivate();   //  A group cannot be reamoved
		btn_Process->deactivate();	//  Processing of individual files is not allowed

		btn_RemFile->activate();	   // a file can be deleted
		btn_InspWnd->activate();	 // a file can be viewed as a micrograph
		vout_CurRadius->deactivate();
		vout_CurBox->deactivate();
	}
	lbl_02->redraw();
 } 

//else printf("No node!!!\n");



//;
}

Fl_Scroll *scrl_procTree=(Fl_Scroll *)0;

Fl_ToggleTree *tree_Proc=(Fl_ToggleTree *)0;

static void cb_tree_Proc(Fl_ToggleTree* o, void*) {
  Fl_ToggleNode *node=o->selected();

if (node){
	vout_CurRadius->deactivate();
	vout_CurBox->deactivate();
	tree_Unproc->unselect();
	tree_Unproc->redraw();
	btn_Process->deactivate();
	btn_AddFile->deactivate();         
	btn_AddGroup->activate();         
	btn_RemFile->deactivate();
	treefoc=1;
   	if (node->can_open()){                     // a groups
		btn_RemGroup->activate();     //  a group can be removed 

		btn_RemFile->deactivate();      // a file cannot be removed without specifing which
		btn_InspWnd->deactivate();    // an unprocessed group cannot be viewed as micrograph
		btn_InspProcWnd->deactivate();

		PrjGroup *gr= (PrjGroup *)node->data();    // show values of radius and box size
		vout_CurRadius->value(gr->radius);          //  in the tabs
		vout_CurBox->value(gr->box);
//		printf("Values: %d, %d\n",gr->radius,gr->box);
	} else {  						//  Single file
		btn_InspWnd->activate();
		btn_InspProcWnd->activate();

	 	btn_RemGroup->deactivate();  
	}
	lbl_02->redraw(); 
};
}

Fl_Button *btn_InspProcWnd=(Fl_Button *)0;

static void cb_btn_InspProcWnd(Fl_Button*, void*) {
  //wnd_Mosaic->show();
/*
PrjOutFile *ouf=OutFiles;
Fl_Button *btn;
char path[200];
Fileimage *a;
unsigned char *data, *ImData_;
Fl_Image *flim;
int i=0;
int  tsize=VBIMAGESIZE*VBIMAGESIZE, x=3,y=3;

*/


//==============  Fill in the group name in the mosaic group choice
int nn;
if (tree_Proc->selected()->can_open()){   // viewing a group
	nn =ch_mos_Group->add(tree_Proc->selected()->label());
}else{
	tree_Proc->traverse_start(tree_Proc->selected());
	tree_Proc->traverse_up();
	nn=ch_mos_Group->add(tree_Proc->current()->label());
}
ch_mos_Group->value(nn);

//=============== Fill in a list of files from the group in the mosaic file choise
Fl_ToggleNode *node=tree_Proc->find((char *)(ch_mos_Group->text()));
node=tree_Proc->traverse_forward();				// Copy list of files in a current group 
ch_mos_File->clear();
while (node && !node->can_open()){				// To microgarph window to the file choise widget
	nn=ch_mos_File->add(node->label(),NULL,NULL,node->data());
	if (node==tree_Proc->selected()) ch_mos_File->value(nn);	
	node=tree_Proc->traverse_forward();
}

fnc_ClearMosaic();
fnc_FillMosaic(ch_mos_File->text());

wnd_Mosaic->show();
}

static unsigned char *image_mosaic[] = {
(unsigned char*)
"20 20 -3 1",
(unsigned char*)
"!\300\300\300\"\0\0\0#X\\X",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!",
(unsigned char*)
"!!\"!!!!\"!!!!\"!!!!\"!!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!!\"!!!!\"!!!!\"!!##\"!!",
(unsigned char*)
"!!\"!##!\"!!!#\"!###\"!!",
(unsigned char*)
"!!\"###!\"!!##\"!##!\"!!",
(unsigned char*)
"!!\"##!!\"!###\"!!!!\"!!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!!\"!!!!\"!!!!\"!!!!\"!!",
(unsigned char*)
"!!\"!###\"!##!\"!##!\"!!",
(unsigned char*)
"!!\"!##!\"!##!\"!!#!\"!!",
(unsigned char*)
"!!\"!!!!\"!!!!\"!!!!\"!!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!!\"!##!\"!##!\"!!!!\"!!",
(unsigned char*)
"!!\"####\"####\"!!!!\"!!",
(unsigned char*)
"!!\"####\"###!\"!!!!\"!!",
(unsigned char*)
"!!\"!##!\"!#!!\"!!!!\"!!",
(unsigned char*)
"!\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"!",
(unsigned char*)
"!!\"!!!!\"!!!!\"!!!!\"!!",
(unsigned char*)
"!!!!!!!!!!!!!!!!!!!!"
};
static Fl_Pixmap pixmap_mosaic(image_mosaic);

static void cb_C(Fl_Button* o, void*) {
  if (o->value()==1) fl_cursor(FL_CURSOR_WAIT, FL_BLACK,FL_WHITE);
else  fl_cursor(FL_CURSOR_DEFAULT, FL_BLACK,FL_WHITE);
}

Fl_Value_Input *vout_CurBox=(Fl_Value_Input *)0;

static void cb_vout_CurBox(Fl_Value_Input* o, void*) {
  PrjGroup *p= (PrjGroup * )tree_Unproc->selected()->data();
p->box=(int)o->value();
CheckSave=1;
//++++++++++++++++++++++++++++++++
if (chb_Autosave->value()==0) {
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
}
//+++++++++++++++++++++++++++++++++;
}

Fl_Value_Input *vout_CurRadius=(Fl_Value_Input *)0;

static void cb_vout_CurRadius(Fl_Value_Input* o, void*) {
  PrjGroup *p= (PrjGroup * )tree_Unproc->selected()->data();
p->radius=(int)o->value();
CheckSave=1;
//+++++++++++++++++++++++++++++
if (chb_Autosave->value()==0) {
	btn_PrjSave->activate();
	btn_PrjSave->redraw();
}

//++++++++++++++++++++++++++++++++++++;
}

Fl_Group *grp_ProjSettings=(Fl_Group *)0;

Fl_Button *btn_PrjSave=(Fl_Button *)0;

static void cb_btn_PrjSave(Fl_Button* o, void*) {
  //
// /*
PrjPath       path;
PrjID	        id;
PrjGroup   *gr;
PrjInFile    *inf;
PrjOutFile *ouf;
EthanCFG ecfg;


const char *ch=tin_Name->value();
const char *ch2=tout_ProjDir->value();


if(*ch2!=0) chdir(ch2);                                           // if project path is set, use it when creating file
if (*ch!=0){

	FILE *fp=fopen(ch,"wb");

	mprintf(" Saving project: %s\n", tin_Name->value() );

	id.tag= PROJECT_TAG;
	id.version =95;
	strcpy(id.Auth_Str, MAGICSTR);
	fwrite(&id, sizeof(PrjID),1,fp);                         // writing project path

	path.tag=PROJECT_PATH;
	path.fileno=OutFileNo;
	strcpy(path.path,tout_ProjDir->value());
	fwrite(&path, sizeof(PrjPath),1,fp);                         // writing project path

	path.tag=ETHAN_PATH;
	strcpy(path.path,tout_EthanCfg->value());
	fwrite(&path, sizeof(PrjPath),1,fp);                         // writing ethan path
	
	path.tag=MRC_PATH;
	path.fileno=InFileNo;
	strcpy(path.path,tout_MRCDir->value());
	fwrite(&path, sizeof(PrjPath),1,fp);                         // writing mrc path

	ecfg.tag=ETHAN_CFG;
	fnc_PackEthanCFG(&ecfg);
	fwrite(&ecfg, sizeof(EthanCFG),1,fp);                         // writing ethan config
	
	gr=Groups;
	while(gr){
		fwrite(gr,sizeof(PrjGroup),1,fp); 
	//	printf("Writing out  %d [%s] processed: %d \n", gr->groupno, gr->grname, gr->processed);
		if (chb_Autosave->value()==0)   mprintf("	Writing group: %s\n",gr->grname);
		gr=gr->next;
	}  // writing out a group list
	
	inf = InFiles;
	while(inf){
		fwrite(inf,sizeof(PrjInFile),1,fp); 
		if (chb_Autosave->value()==0)  	
			mprintf("	Writing input file: %s\n", inf->infname);
		inf=inf->next;
	}  // writing out an InFile list
	
	ouf = OutFiles;
	int n=0;
	while(ouf){
		fwrite(ouf,sizeof(PrjOutFile),1,fp); 
	//	printf(" Writing out outfiles %s \n", ouf->oufname);
		ouf=ouf->next;
		n++;
	}  // writing out an OutFile list
	fclose(fp);
	if (chb_Autosave->value()==0){
  		mprintf("	Wrote %d output files \n",n);
		mprintf(" Save successful.\n");
		o->deactivate();
		o->redraw();
	}
	CheckSave=0;

}else o->deactivate();


// */
//;
}

Fl_Input *tin_DefRad=(Fl_Input *)0;

Fl_Input *tin_DefBox=(Fl_Input *)0;

Fl_Button *btn_PrjClear=(Fl_Button *)0;

static void cb_btn_PrjClear(Fl_Button*, void*) {
  PrjGroup *gr=Groups, *gr1;
PrjInFile  *inf=InFiles, *inf1;
PrjOutFile *ouf=OutFiles, *ouf1;

btn_RemGroup->deactivate();
btn_Process->deactivate();
btn_AddFile->deactivate();

char mbuf[PATH_MAX];
getwd(mbuf);
strcat(mbuf,"/");
tout_ProjDir->value(mbuf);
tout_MRCDir->value(mbuf);

tout_EthanCfg->value("");
tin_Name->value("");
vout_CurRadius->value(0);
vout_CurBox->value(0);
while (tree_Unproc->first()) tree_Unproc->clear();
while (tree_Proc->first()) tree_Proc->clear();
scrl_UnpTree->redraw();
scrl_procTree->redraw();

btn_PrjSave->deactivate();

Fl::flush();
//============================
// clear group list, same should be done with In and Out files.
while (gr){
	gr1=gr->next;
	delete(gr);
	gr=gr1;
}
Groups=NULL;
while (inf){
	inf1=inf->next;
	delete(inf);
	inf=inf1;
}
InFiles=NULL;
while (ouf){
	ouf1=ouf->next;
	delete(ouf);
	ouf=ouf1;
}
OutFiles=NULL;
fnc_ClearEthanCFG();
tout_EthanCfg->value("/tmp/ethan.cfg");
mprintf("  Project cleared.\n");
}

Fl_Check_Button *btn_Autosave_=(Fl_Check_Button *)0;

static void cb_btn_Autosave_(Fl_Check_Button* o, void*) {
  if (o->value()==1) {
	if (strcmp(tin_Name->value(),"")==0){
		fl_alert("Specify project name, before\n setting autosave mode.\n");
		o->value(0);
	}else btn_PrjSave->deactivate();
}
printf("Autosave : %d\n", o->value());
}

Fl_Input *tin_Name=(Fl_Input *)0;

Fl_Group *grp_Ethan_Config=(Fl_Group *)0;

Fl_Output *tout_EthanCfg=(Fl_Output *)0;

Fl_Button *btn_EthanCfgBrowse=(Fl_Button *)0;

static void cb_btn_EthanCfgBrowse(Fl_Button*, void*) {
  char *p = fl_file_chooser("Pick a file","*","");
if (p) tout_EthanCfg->value(p);
}

static void cb_Default1(Fl_Check_Button* o, void*) {
  //


if (o->value()==1){
	tout_EthanCfg->value("");
	btn_EthanCfgBrowse->deactivate();
	tout_EthanCfg->deactivate();

	lbl_01->redraw();
}


//;
}

static void cb_Custom(Fl_Check_Button* o, void*) {
  if (o->value()==1){
	btn_EthanCfgBrowse->activate();
	tout_EthanCfg->activate();
	lbl_01->redraw();
};
}

static void cb_Configure(Fl_Button*, void*) {
  //char *p = fl_file_chooser("Pick a file","*","");
//if (p) tout_EthanCfg->value(p);

wnd_EthanCFG->show();
}

Fl_Button *lbl_02=(Fl_Button *)0;

Fl_Button *lbl_01=(Fl_Button *)0;

Fl_Menu_Bar *mnu_MainMenu=(Fl_Menu_Bar *)0;

static void cb_mni_New(Fl_Menu_*, void*) {
  btn_PrjClear->do_callback();
wnd_Project->label("SPADE: No name set.");
btn_SetPrjDir->activate();
}

static void cb_mni_Load(Fl_Menu_*, void*) {
  //


PrjPath path;
PrjGroup   *gr  = (PrjGroup *) (&path), * gr1;  // the key here is that all records are
PrjInFile    *inf  = (PrjInFile *)  (&path), * inf1;  // of the same size! 
PrjOutFile *ouf  = (PrjOutFile *)(&path), *ouf1;
PrjID *id  = (PrjID *)(&path);
Fl_ToggleNode *tnode;
char buf[500];
int a;


char *p=fl_file_chooser("Load Project","*.spa","");

if (p){

	if (fnc_FileExists(p)==0){                                // should check for readability/writeability
		fl_alert(" No file selected!\n");
		return;
	}

 	FILE *fp = fopen(p,"rb");

//       for(i=strlen(p); i>0;i--)
//                if (p[i]=='/'){ p[i+1]=0;  break; }

        a=fread(&path, sizeof (PrjPath),1,fp);
	if (strcmp(id->Auth_Str, MAGICSTR)!=0){					// check to see if file is of a correct type, check key string
		fl_alert("File \"%s\" \n is not an SPADE project file.",p);       // if not allert and return
		fclose(fp);
		return;	
	}
	btn_PrjClear->do_callback();
	int b=0;
	char *pname=p;										  // extract projectname
        for(int i=strlen(p); i>0;i--)								// from the path.
                if (p[i]=='/'){ 
			pname = strdup(p+i+1);  
			p[i+1]=0;
			b=1;
			break; 
		} 
	sprintf(buf, "SPADE: %s",pname);
 	wnd_Project->label(buf);
	tin_Name->value(pname);

	char buf1 [PATH_MAX];
	char buf2 [PATH_MAX];
	getwd(buf1);

	if (p[0]=='/') tout_ProjDir->value(p);			// if given path is absolute, use only it
	else {
		if (b==1) sprintf(buf2,"%s/%s",buf1,p);         //  if given path exists then project path is a catenation
		else sprintf(buf2,"%s/",buf1);			     // else project path is just curdir
		tout_ProjDir->value(buf2);
	}

//	printf("Tout_projectpath: [%s] \n",tout_ProjDir->value());
	btn_PrjSave->activate(); 							   // maybe not?
	tout_EthanCfg->value("/tmp/ethan.cfg");
	while(a!=0){
		switch (path.tag){
//			case PROJECT_PATH:  tout_ProjDir->value(path.path); break;
			case ETHAN_CFG:		fnc_UnPackEthanCFG((EthanCFG *)&path); break;
			case ETHAN_PATH:      tout_EthanCfg->value(path.path); break;
			case  MRC_PATH:         tout_MRCDir->value(path.path); break;

			case GROUP:  
				gr1= new PrjGroup();
				memcpy(gr1,gr, sizeof(PrjGroup));
				gr1->next=Groups;
				mprintf("	Group: %s \n",gr->grname);
				Groups=gr1;  GroupNo++;
				if (gr1->processed==0) tree_Unproc->add_next(gr->grname,1,NULL,gr1);
				else tree_Proc->add_next(gr->grname,1,NULL,gr1);
				break;
			case INPUT_FILE:
				inf1= new PrjInFile();
				memcpy(inf1,inf, sizeof(PrjInFile));
				mprintf("	Inputfile: %s from group %s\n", inf1->infname,inf1->grname);
				inf1->next=InFiles;
				InFiles=inf1;  InFileNo++;
				gr=Groups;
				while (gr){
					if (strcmp (gr->grname,inf1->grname)==0){		// Found the group
						if (gr->processed==0){					    // If group is not processed
  							tnode =tree_Unproc->find(gr->grname);
							tree_Unproc->add_sub(inf1->infname,0,NULL,inf1);
						}else{									// If group is processed
							tnode =tree_Proc->find(gr->grname);
							tree_Proc->add_sub(inf1->infname,0,NULL,inf1);	
						}
					}
					gr=gr->next;
				}
				break;

			case OUTPUT_FILE:
				ouf1= new PrjOutFile();
				memcpy(ouf1,ouf, sizeof(PrjOutFile));
				ouf1->next=OutFiles;
				OutFiles=ouf1;  OutFileNo++;
				break;
		}
		a=fread(&path, sizeof (PrjPath),1,fp);
	}
	fclose(fp);

//==================================================
//  Data structures are loaded time to build the tree
//  first the groups
//   gr = Groups;
//   while(gr){ tree_Unproc->add_next(gr->grname,1); gr=gr->next;} 

char *tmp=new char[200];
	inf=InFiles;
	while (inf){
		sprintf(tmp,"%s%s",inf->infpath, inf->infname);
		if (fnc_FileExists(tmp)==0){ 
			fl_alert(" Unable to load project %s: \n Input file %s doesn't exist.",tin_Name->value(),inf->infname);
			btn_PrjClear->do_callback();
			return;
		}
		inf=inf->next;
	}
	ouf=OutFiles;
	while (ouf){
		sprintf(tmp,"%s%s",tout_ProjDir->value(), ouf->oufname);
		if (fnc_FileExists(tmp)==0){
			 fl_alert(" Unable to load project %s: \n Output file %s doesn't exist.",tin_Name->value(), ouf->oufname);
			btn_PrjClear->do_callback();
			return;
		}
		ouf=ouf->next;
	}
	mprintf(" Load sucessful.\n");
        sprintf(buf, " Project: %s",p);        
	btn_SetPrjDir->deactivate();
};
}

static void cb_mni_Save(Fl_Menu_*, void*) {
  // Menu button Save 
char buf[500], *filename;

if (strcmp(tin_Name->value(),"")==0) {

	char *p=fl_file_chooser("Save project as ","*",tout_ProjDir->value());
	if (p==NULL) return;
	if (!(strcmp(&p[strlen(p)-4],".spa")==0)){
		sprintf(buf, "%s.spa", p);
		free(p); p= strdup(buf);
	}

	filename=p;
	for(int i=strlen(p); i>0;i--)
		if (p[i]=='/'){ 
			filename=strdup(p+i+1);  
			break; 
	}  

	if (fnc_FileExists(p)) 
		if (!fl_ask("File: %s exists, overwrite?",filename)) return;

	if (p && (strlen(p)!=0)){  // if p is not null or an empty string
   		tin_Name->value(p);
   		btn_PrjSave->do_callback();

   		sprintf(buf, " Project: %s", filename);
  		 wnd_Project->label(buf);
  		btn_SetPrjDir->deactivate();
	}
}
btn_PrjSave->do_callback();




//;
}

static void cb_mni_SaveAs(Fl_Menu_*, void*) {
  // Menu item Save As...

char *p=fl_file_chooser("Save project as ","*",tout_ProjDir->value());
char buf[500], *filename;
//, *directory;
if (p==NULL) return;

	if (!(strcmp(&p[strlen(p)-4],".spa")==0)){
		sprintf(buf, "%s.spa", p);
		free(p); p= strdup(buf);
	}

	filename=p;
	for(int i=strlen(p); i>0;i--)
		if (p[i]=='/'){ 
			filename=strdup(p+i+1);  
			break; 
	}  


if (fnc_FileExists(p)) 
	if (!fl_ask("File: %s exists, overwrite?",filename)) return;

//printf("[%s]\n",p);
//perform all sorts of checks here

if (p && (strlen(p)!=0)){  // if p is not null or an empty string
   tin_Name->value(p);
   btn_PrjSave->do_callback();

   sprintf(buf, " Project: %s", filename);
   wnd_Project->label(buf);
   btn_SetPrjDir->deactivate();
};
}

static void cb_mni_ConfEth(Fl_Menu_*, void*) {
  wnd_EthanCFG->show();
}

static void cb_chb_Autosave(Fl_Menu_* o, void*) {
  if (o->value()==1) {
	if (strcmp(tin_Name->value(),"")==0){
		fl_alert("Specify project name, before\n setting autosave mode.\n");
		o->value(0);
	}else btn_PrjSave->deactivate();
}
printf("Autosave : %d\n", o->value());
}

static void cb_mni_Exit(Fl_Menu_*, void*) {
  time_t t=time(NULL);

if (chb_Autosave->value()==0) {											// if autosave feature is off
	if (CheckSave==1) {											        // if file has not been saved
		if (fl_ask("Current project is not saved, save it before exiting?")==1) {       // prompt user for saving
			if (strcmp(tin_Name->value(),"")==0) {						     // if no file name set
				fl_alert(" Without a name project cannot be saved.");		     // warn user
				return;											        // and get put 
			} else btn_PrjSave->do_callback();						     // otherwise save project
		}
	}
} else {						 //  if autosave is on 
//	btn_Autosave->value(0);           // Small hack to write the data to log
	chb_Autosave->clear();		  // change for better interface
	btn_PrjSave->do_callback();      // save project no matter what.
}
mprintf("*** Session closed: %s\n",ctime(&t));   // log exit.
exit(0);
}

static void cb_About(Fl_Menu_*, void*) {
  wnd_About->show();
}

Fl_Menu_Item menu_mnu_MainMenu[] = {
 {"  Project    ", 0,  0, 0, 64, 0, 0, 14, 0},
 {"  New  ", 0,  (Fl_Callback*)cb_mni_New, 0, 0, 0, 0, 14, 0},
 {"  Open ...", 0,  (Fl_Callback*)cb_mni_Load, 0, 0, 0, 0, 14, 0},
 {"  Save", 0,  (Fl_Callback*)cb_mni_Save, 0, 0, 0, 0, 14, 0},
 {"  Save as ...  ", 0,  (Fl_Callback*)cb_mni_SaveAs, 0, 128, 0, 0, 14, 0},
 {"  Configure ethan ...", 0,  (Fl_Callback*)cb_mni_ConfEth, 0, 0, 0, 0, 14, 0},
 {"  Autosave  ", 0,  (Fl_Callback*)cb_chb_Autosave, 0, 130, 0, 0, 14, 0},
 {"  Exit  ", 0,  (Fl_Callback*)cb_mni_Exit, 0, 0, 0, 0, 14, 0},
 {0},
 {"Windows", 0,  0, 0, 80, 0, 0, 14, 0},
 {"  Micrograph  ", 0,  0, 0, 0, 0, 0, 14, 0},
 {"  Mosaic  ", 0,  0, 0, 0, 0, 0, 14, 0},
 {0},
 {"  About  ", 0,  (Fl_Callback*)cb_About, 0, 0, 0, 0, 14, 0},
 {0}
};

int main(int argc, char **argv) {
  Fl_Window* w;
  { Fl_Window* o = wnd_NewGroup = new Fl_Window(333, 117, "New Group");
    w = o;
    { Fl_Button* o = new Fl_Button(175, 80, 90, 25, "Cancel");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_Cancel);
    }
    { Fl_Group* o = new Fl_Group(10, 10, 310, 60);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Input* o = tin_GroupName = new Fl_Input(170, 25, 130, 30, "New Group Name :");
        o->labelfont(1);
      }
      o->end();
    }
    { Fl_Button* o = new Fl_Button(70, 80, 90, 25, "OK");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_OK);
    }
    //  This whole window should be removed as it is no longer used
    o->end();
  }
  { Fl_Window* o = wnd_InspectUnproc = new Fl_Window(787, 710, "SPADE: Micrograph Viewer");
    w = o;
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 785, 25);
      o->box(FL_THIN_UP_BOX);
      o->hide();
      o->menu(menu_);
    }
    { Fl_Group* o = grp_UnprocStatus = new Fl_Group(0, 690, 785, 20);
      { Fl_Button* o = new Fl_Button(0, 690, 90, 20);
        o->box(FL_DOWN_BOX);
        o->color(16);
      }
      { Fl_Button* o = btn_stsComment = new Fl_Button(90, 690, 605, 20);
        o->box(FL_DOWN_BOX);
      }
      { Fl_Button* o = new Fl_Button(695, 690, 90, 20, "SPADE");
        o->box(FL_DOWN_BOX);
      }
      o->end();
    }
    { Fl_Group* o = grp_Choises = new Fl_Group(0, 5, 810, 110);
      { Fl_Group* o = grpZoomnPan = new Fl_Group(385, 20, 160, 85);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Button* o = new Fl_Button(395, 70, 25, 25, "1:1");
          o->labelfont(1);
          o->callback((Fl_Callback*)cb_1);
        }
        { Fl_Button* o = new Fl_Button(430, 70, 25, 25);
          pixmap_tofit.label(o);
          o->labelfont(1);
          o->callback((Fl_Callback*)cb_gfx);
        }
        { Fl_Button* o = btn_PanUp = new Fl_Button(495, 35, 20, 20);
          pixmap_ar_up.label(o);
          o->callback((Fl_Callback*)cb_btn_PanUp);
        }
        { Fl_Button* o = btn_PanLeft = new Fl_Button(475, 55, 20, 20);
          pixmap_ar_left.label(o);
          o->callback((Fl_Callback*)cb_btn_PanLeft);
        }
        { Fl_Button* o = btn_PanRight = new Fl_Button(515, 55, 20, 20);
          pixmap_ar_right.label(o);
          o->callback((Fl_Callback*)cb_btn_PanRight);
        }
        { Fl_Button* o = btn_PanDown = new Fl_Button(495, 75, 20, 20);
          pixmap_ar_dn.label(o);
          o->callback((Fl_Callback*)cb_btn_PanDown);
        }
        { Fl_Value_Input* o = new Fl_Value_Input(460, 55, 30, 20);
          o->hide();
        }
        vout_Zoom = new Fl_Value_Output(395, 35, 60, 25);
        o->end();
      }
      { Fl_Group* o = grp_GroupnFile = new Fl_Group(15, 20, 185, 85);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Choice* o = ch_Group = new Fl_Choice(70, 35, 120, 25, "Group :");
          o->box(FL_DOWN_BOX);
          o->color(7);
          o->deactivate();
        }
        { Fl_Choice* o = ch_File = new Fl_Choice(70, 70, 120, 25, "File :");
          o->box(FL_DOWN_BOX);
          o->color(7);
          o->selection_color(8);
          o->callback((Fl_Callback*)cb_ch_File);
        }
        o->end();
      }
      { Fl_Group* o = grp_Ethan = new Fl_Group(205, 20, 175, 85);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Value_Input* o = vin_Radius = new Fl_Value_Input(270, 35, 65, 25, "Radius :");
          o->hide();
          o->deactivate();
        }
        { Fl_Value_Input* o = vin_Box = new Fl_Value_Input(285, 70, 50, 25, "Box Size :");
          o->hide();
          o->deactivate();
        }
        { Fl_Button* o = btn_EthanPrev = new Fl_Button(345, 35, 25, 25);
          o->type(1);
          pixmap_prev.label(o);
          o->callback((Fl_Callback*)cb_btn_EthanPrev);
        }
        vout_Box = new Fl_Value_Output(285, 70, 50, 25, "Box Size :");
        vout_Radius = new Fl_Value_Output(270, 35, 65, 25, "Radius :");
        o->end();
      }
      { Fl_Button* o = new Fl_Button(20, 10, 110, 20, "File selection :");
        o->box(FL_FLAT_BOX);
        o->down_box(FL_FLAT_BOX);
        o->labelfont(1);
      }
      { Fl_Button* o = new Fl_Button(210, 10, 110, 20, "Ethan Params:");
        o->box(FL_FLAT_BOX);
        o->down_box(FL_FLAT_BOX);
        o->labelfont(1);
      }
      { Fl_Button* o = new Fl_Button(410, 10, 100, 20, "Zoom && Pan:");
        o->box(FL_FLAT_BOX);
        o->down_box(FL_FLAT_BOX);
        o->labelfont(1);
      }
      { Fl_Button* o = btn_Return1 = new Fl_Button(550, 20, 85, 35, "CLOSE");
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_btn_Return1);
      }
      o->resizable(NULL);
      o->end();
    }
    { Fl_Group* o = new Fl_Group(0, 120, 785, 570);
      { MicroGraphBox* o = box_Image = new MicroGraphBox(40, 120, 745, 570);
        o->box(FL_THIN_DOWN_BOX);
        o->color(0);
        Fl_Group::current()->resizable(o);
        box_Image->SetWidgetRadius(vout_Radius);
        box_Image->SetWidgetBoxSize(vout_Box);
        box_Image->SetWidgetZoom(vout_Zoom);
      }
      { Fl_Group* o = new Fl_Group(0, 120, 35, 425);
        { Fl_Button* o = new Fl_Button(5, 200, 25, 25);
          o->type(102);
          pixmap_select.label(o);
          o->callback((Fl_Callback*)cb_gfx1);
          o->hide();
          o->deactivate();
        }
        { Fl_Button* o = new Fl_Button(5, 125, 25, 25);
          o->type(102);
          pixmap_zoomin.label(o);
          o->callback((Fl_Callback*)cb_gfx2);
        }
        { Fl_Button* o = new Fl_Button(5, 225, 25, 25);
          o->type(102);
          pixmap_zoomout.label(o);
          o->hide();
          o->deactivate();
        }
        { Fl_Button* o = btn_SetRadiusMode = new Fl_Button(5, 150, 25, 25);
          o->type(102);
          pixmap_radius.label(o);
          o->callback((Fl_Callback*)cb_btn_SetRadiusMode);
        }
        { Fl_Button* o = btn_SetBoxMode = new Fl_Button(5, 175, 25, 25);
          o->type(102);
          pixmap_bsize.label(o);
          o->callback((Fl_Callback*)cb_btn_SetBoxMode);
        }
        o->resizable(0);
        o->end();
      }
      o->end();
    }
    o->set_modal();
    o->end();
    o->resizable(o);
  }
  { Fl_Window* o = wnd_Mosaic = new Fl_Window(787, 530, "SPADE: Mosaic Results Viewer");
    w = o;
    { Fl_Scroll* o = scrl_Mosaic = new Fl_Scroll(0, 80, 580, 430);
      o->box(FL_THIN_DOWN_BOX);
      o->callback((Fl_Callback*)cb_scrl_Mosaic);
      o->end();
    }
    { Fl_Group* o = scrl_test = new Fl_Group(25, 25, 765, 505);
      o->end();
    }
    { Fl_Scroll* o = scrl_Delete = new Fl_Scroll(615, 30, 170, 450);
      o->box(FL_THIN_DOWN_BOX);
      o->end();
    }
    { Fl_Group* o = grp_ProcStatus = new Fl_Group(0, 510, 785, 20);
      { Fl_Button* o = new Fl_Button(0, 510, 100, 20);
        o->box(FL_DOWN_BOX);
        o->color(16);
      }
      { Fl_Button* o = new Fl_Button(100, 510, 600, 20);
        o->box(FL_DOWN_BOX);
      }
      { Fl_Button* o = new Fl_Button(700, 510, 85, 20, "SPADE");
        o->box(FL_DOWN_BOX);
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(5, 180, 40, 140);
      o->box(FL_ENGRAVED_FRAME);
      o->hide();
      { Fl_Button* o = new Fl_Button(10, 190, 30, 30);
        pixmap_totop.label(o);
      }
      { Fl_Button* o = new Fl_Button(10, 220, 30, 30);
        pixmap_up.label(o);
      }
      { Fl_Button* o = new Fl_Button(10, 250, 30, 30);
        pixmap_down.label(o);
      }
      { Fl_Button* o = new Fl_Button(10, 280, 30, 30);
        pixmap_tobottom.label(o);
      }
      o->end();
    }
    { Fl_Button* o = new Fl_Button(0, 60, 75, 20, "Maps : ");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(615, 10, 105, 20, "For deletion:");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(585, 170, 25, 25);
      pixmap_forth.label(o);
      o->callback((Fl_Callback*)cb_gfx3);
    }
    { Fl_Button* o = new Fl_Button(585, 200, 25, 25);
      pixmap_back.label(o);
      o->callback((Fl_Callback*)cb_gfx4);
    }
    { Fl_Button* o = new Fl_Button(615, 480, 170, 30, "Delete");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_Delete);
    }
    { Fl_Group* o = grp_FileControl = new Fl_Group(5, 10, 575, 50);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Choice* o = ch_mos_Group = new Fl_Choice(60, 20, 120, 25, "Group :");
        o->box(FL_DOWN_BOX);
        o->color(7);
        o->deactivate();
      }
      { Fl_Choice* o = ch_mos_File = new Fl_Choice(240, 20, 120, 25, "File :");
        o->box(FL_DOWN_BOX);
        o->color(7);
        o->selection_color(8);
        o->callback((Fl_Callback*)cb_ch_mos_File);
      }
      { Fl_Group* o = new Fl_Group(405, 20, 155, 35);
        o->hide();
        new Fl_Value_Output(465, 25, 40, 25);
        { Fl_Button* o = btn_NextProcFile = new Fl_Button(505, 25, 25, 25);
          pixmap_next.label(o);
        }
        { Fl_Button* o = btn_PrevProcFile = new Fl_Button(440, 25, 25, 25);
          pixmap_previ.label(o);
        }
        { Fl_Button* o = btn_FirstProcFile = new Fl_Button(415, 25, 25, 25);
          pixmap_first.label(o);
        }
        { Fl_Button* o = btn_LastProcFile = new Fl_Button(530, 25, 25, 25);
          pixmap_last.label(o);
        }
        o->end();
      }
      o->resizable(0);
      o->end();
    }
    { Fl_Button* o = btn_Return2 = new Fl_Button(485, 20, 85, 30, "CLOSE");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_btn_Return2);
    }
    o->set_modal();
    o->end();
    o->resizable(o);
  }
  { Fl_Window* o = wnd_MapOps = new Fl_Window(457, 441);
    w = o;
    { Fl_Box* o = new Fl_Box(20, 15, 200, 200, "label");
      o->box(FL_DOWN_BOX);
      o->color(7);
    }
    { Fl_Box* o = new Fl_Box(235, 15, 200, 200, "label");
      o->box(FL_DOWN_BOX);
      o->color(7);
    }
    { Fl_Group* o = new Fl_Group(235, 230, 200, 150);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Check_Button* o = new Fl_Check_Button(250, 245, 95, 25, "   Equalize ");
        o->type(102);
        o->down_box(FL_DIAMOND_DOWN_BOX);
      }
      { Fl_Check_Button* o = new Fl_Check_Button(250, 275, 95, 25, "   Histogram");
        o->type(102);
        o->down_box(FL_DIAMOND_DOWN_BOX);
      }
      { Fl_Check_Button* o = new Fl_Check_Button(250, 305, 95, 25, "   Hor. Line");
        o->type(102);
        o->down_box(FL_DIAMOND_DOWN_BOX);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(255, 345, 160, 20);
        o->type(1);
        o->maximum(200);
        o->step(1);
      }
      o->end();
    }
    { Fl_Button* o = new Fl_Button(245, 220, 70, 25, "Modes : ");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(235, 395, 100, 30, "Cancel");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_Cancel1);
    }
    { Fl_Button* o = new Fl_Button(120, 395, 100, 30, "Apply To All");
      o->labelfont(1);
      o->callback((Fl_Callback*)cb_Apply);
    }
    { Fl_Group* o = new Fl_Group(20, 230, 200, 150);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Value_Slider* o = new Fl_Value_Slider(35, 260, 170, 20, "Radius :");
        o->type(1);
        o->maximum(500);
        o->step(1);
        o->align(FL_ALIGN_TOP_LEFT);
      }
      { Fl_Value_Slider* o = new Fl_Value_Slider(35, 305, 170, 20, "Soft Edge :");
        o->type(1);
        o->maximum(500);
        o->step(1);
        o->align(FL_ALIGN_TOP_LEFT);
      }
      new Fl_Button(55, 340, 120, 25, "Blend");
      o->end();
    }
    { Fl_Button* o = new Fl_Button(30, 220, 50, 25, "Map : ");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    o->end();
  }
  { Fl_Window* o = wnd_ProcessProgress = new Fl_Window(389, 106);
    w = o;
    { Fl_Button* o = btn_ProgressRep = new Fl_Button(40, 25, 305, 45, "Test!");
      o->box(FL_ENGRAVED_FRAME);
    }
    o->end();
  }
  { Fl_Window* o = wnd_SelectFiles = new Fl_Window(278, 290, "Select data files");
    w = o;
    { Fl_Browser* o = brws_MRCfiles = new Fl_Browser(5, 5, 270, 235);
      o->type(3);
    }
    { Fl_Button* o = new Fl_Button(15, 250, 75, 30, "Select All");
      o->callback((Fl_Callback*)cb_Select);
    }
    { Fl_Button* o = new Fl_Button(195, 250, 75, 30, "Cancel");
      o->callback((Fl_Callback*)cb_Cancel2);
    }
    { Fl_Button* o = new Fl_Button(105, 250, 75, 30, "OK");
      o->callback((Fl_Callback*)cb_OK1);
    }
    o->end();
  }
  { Fl_Window* o = wnd_EthanCFG = new Fl_Window(405, 288, "Ethan Configuration");
    w = o;
    { Fl_Group* o = new Fl_Group(25, 15, 360, 155);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Value_Input* o = vin_EthanParHeight = new Fl_Value_Input(135, 40, 50, 25, "Height : ");
        o->value(0.5);
      }
      { Fl_Value_Input* o = vin_EthanParWidth = new Fl_Value_Input(135, 70, 50, 25, "Square width : ");
        o->maximum(100);
        o->value(1);
      }
      { Fl_Value_Input* o = vin_EthanParRWidth = new Fl_Value_Input(135, 100, 50, 25, "Ring width : ");
        o->minimum(1);
        o->maximum(100);
        o->value(1.2);
      }
      { Fl_Value_Input* o = vin_EthanParDist = new Fl_Value_Input(135, 130, 50, 25, "Distance : ");
        o->value(0.1);
      }
      { Fl_Value_Input* o = vin_EthanParReduct = new Fl_Value_Input(330, 40, 40, 25, "Reduction : ");
        o->maximum(100);
      }
      { Fl_Check_Button* o = chb_EthanParResIm = new Fl_Check_Button(330, 100, 30, 25, "Make result image : ");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Check_Button* o = chb_EthanParRefine = new Fl_Check_Button(330, 130, 30, 25, "Refine : ");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->value(1);
        o->align(FL_ALIGN_LEFT);
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(25, 190, 360, 50);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Check_Button* o = chb_EthanTestSector = new Fl_Check_Button(110, 205, 30, 25, "Sector : ");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->value(1);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Check_Button* o = chb_EthanTestHeight = new Fl_Check_Button(215, 205, 30, 25, "Height : ");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->value(1);
        o->align(FL_ALIGN_LEFT);
      }
      { Fl_Check_Button* o = chb_EthanTestDistance = new Fl_Check_Button(330, 205, 30, 25, "Distance : ");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->value(1);
        o->align(FL_ALIGN_LEFT);
      }
      o->end();
    }
    { Fl_Box* o = new Fl_Box(35, 5, 90, 25, "Parameters");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Box* o = new Fl_Box(35, 180, 50, 25, "Tests");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(105, 255, 80, 25, "Apply");
      o->callback((Fl_Callback*)cb_Apply1);
    }
    { Fl_Button* o = new Fl_Button(200, 255, 80, 25, "Default");
      o->callback((Fl_Callback*)cb_Default);
    }
    o->end();
  }
  { Fl_Window* o = wnd_About = new Fl_Window(352, 385, "SPADE: About");
    w = o;
    { Fl_Button* o = new Fl_Button(135, 350, 95, 25, "OK");
      o->callback((Fl_Callback*)cb_OK2);
    }
    { Fl_Group* o = new Fl_Group(20, 15, 315, 325);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Button* o = new Fl_Button(30, 35, 295, 30, "SPADE v1.0");
        o->box(FL_FLAT_BOX);
        o->labelfont(1);
        o->labelsize(18);
        o->align(FL_ALIGN_WRAP);
      }
      { Fl_Button* o = new Fl_Button(25, 60, 305, 45, "Spherical PArticle DEtection from Electron Micrographs");
        o->box(FL_FLAT_BOX);
        o->align(FL_ALIGN_WRAP);
      }
      { Fl_Button* o = new Fl_Button(25, 100, 305, 30, "Copyright 2000 A. Verkhovsky");
        o->box(FL_FLAT_BOX);
        o->labelfont(1);
        o->align(FL_ALIGN_WRAP);
      }
      { Fl_Button* o = new Fl_Button(80, 130, 190, 70, "Copyright 1999          T.Kaituri, E. Kallioniemi,         J. Paaso, M. Ter\
\344s and        J. Virtanen");
        o->box(FL_FLAT_BOX);
        o->align(FL_ALIGN_WRAP);
      }
      { Fl_Button* o = new Fl_Button(25, 215, 305, 50, "This program is free software; you can redistribute it and/or modify it under\
 the terms of the GNU General Public License as published by the Free Software\
 Foundation; either version 2 of the License, or (at your option) any later ve\
rsion.");
        o->box(FL_FLAT_BOX);
        o->labelsize(10);
        o->align(FL_ALIGN_WRAP);
      }
      { Fl_Button* o = new Fl_Button(25, 265, 305, 65, "This program is distributed in the hope that it will be useful, but WITHOUT A\
NY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS F\
OR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.");
        o->box(FL_FLAT_BOX);
        o->labelsize(10);
        o->align(FL_ALIGN_WRAP);
      }
      o->end();
    }
    o->end();
  }
  { Fl_Window* o = wnd_Project = new Fl_Window(727, 434, "SPADE: Project Properties");
    w = o;
    o->callback((Fl_Callback*)cb_wnd_Project);
    { Fl_Group* o = grp_DirSettings = new Fl_Group(10, 350, 705, 70);
      o->box(FL_ENGRAVED_FRAME);
      o->align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE);
      { Fl_Output* o = tout_ProjDir = new Fl_Output(75, 375, 195, 25, "Project : ");
        o->box(FL_THIN_DOWN_BOX);
      }
      { Fl_Output* o = tout_MRCDir = new Fl_Output(420, 375, 195, 25, "Data : ");
        o->box(FL_THIN_DOWN_BOX);
        o->value(".");
      }
      { Fl_Button* o = btn_SetPrjDir = new Fl_Button(275, 375, 70, 25, "Browse");
        o->callback((Fl_Callback*)cb_btn_SetPrjDir);
      }
      { Fl_Button* o = new Fl_Button(620, 375, 70, 25, "Browse");
        o->callback((Fl_Callback*)cb_Browse);
      }
      o->end();
    }
    { Fl_Group* o = grp_FileSettings = new Fl_Group(10, 45, 705, 280);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Group* o = grp_ProcUnproc = new Fl_Group(340, 105, 45, 110);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Button* o = btn_Process = new Fl_Button(350, 115, 25, 25);
          pixmap_forth.label(o);
          o->callback((Fl_Callback*)cb_btn_Process);
          o->deactivate();
        }
        { Fl_Button* o = btn_RemGroup = new Fl_Button(350, 175, 25, 25);
          pixmap_sub.label(o);
          o->callback((Fl_Callback*)cb_btn_RemGroup);
          o->deactivate();
        }
        { Fl_Button* o = btn_InspWnd = new Fl_Button(350, 145, 25, 25);
          pixmap_eye.label(o);
          o->callback((Fl_Callback*)cb_btn_InspWnd);
          o->deactivate();
        }
        o->end();
      }
      { Fl_Group* o = grp_UnprocBtns = new Fl_Group(20, 105, 45, 105);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Button* o = btn_AddFile = new Fl_Button(35, 150, 20, 20);
          pixmap_adds.label(o);
          o->callback((Fl_Callback*)cb_btn_AddFile);
          o->deactivate();
        }
        { Fl_Button* o = btn_RemFile = new Fl_Button(35, 175, 20, 20);
          pixmap_subs.label(o);
          o->callback((Fl_Callback*)cb_btn_RemFile);
          o->deactivate();
        }
        { Fl_Button* o = btn_AddGroup = new Fl_Button(30, 115, 25, 25);
          pixmap_add.label(o);
          o->callback((Fl_Callback*)cb_btn_AddGroup);
        }
        o->end();
      }
      { Fl_Scroll* o = scrl_UnpTree = new Fl_Scroll(75, 75, 260, 175);
        o->type(6);
        o->box(FL_THIN_DOWN_FRAME);
        o->color(7);
        { Fl_ToggleTree* o = tree_Unproc = new Fl_ToggleTree(75, 75, 260, 175);
          o->color(7);
          o->callback((Fl_Callback*)cb_tree_Unproc);
          o->draw_lines(1);
          o->redraw();
        }
        o->end();
      }
      { Fl_Scroll* o = scrl_procTree = new Fl_Scroll(390, 75, 260, 175);
        o->type(6);
        o->box(FL_THIN_DOWN_FRAME);
        o->color(7);
        { Fl_ToggleTree* o = tree_Proc = new Fl_ToggleTree(390, 75, 260, 175);
          o->color(7);
          o->callback((Fl_Callback*)cb_tree_Proc);
          o->draw_lines(1);
        }
        o->end();
      }
      { Fl_Button* o = new Fl_Button(395, 55, 110, 20, "Processed :");
        o->box(FL_NO_BOX);
      }
      { Fl_Button* o = new Fl_Button(100, 55, 110, 20, "Unprocessed :");
        o->box(FL_NO_BOX);
      }
      { Fl_Group* o = new Fl_Group(655, 115, 45, 85);
        o->box(FL_ENGRAVED_FRAME);
        { Fl_Button* o = btn_InspProcWnd = new Fl_Button(665, 140, 25, 25);
          pixmap_mosaic.label(o);
          o->callback((Fl_Callback*)cb_btn_InspProcWnd);
          o->deactivate();
        }
        o->end();
      }
      { Fl_Button* o = new Fl_Button(565, 275, 65, 25, "C shape");
        o->type(1);
        o->callback((Fl_Callback*)cb_C);
        o->hide();
        o->deactivate();
      }
      { Fl_Group* o = new Fl_Group(170, 265, 330, 55);
        { Fl_Value_Input* o = vout_CurBox = new Fl_Value_Input(390, 275, 90, 30, "Box :");
          o->maximum(500);
          o->step(1);
          o->callback((Fl_Callback*)cb_vout_CurBox);
          o->deactivate();
        }
        { Fl_Value_Input* o = vout_CurRadius = new Fl_Value_Input(245, 275, 90, 30, "Radius :");
          o->callback((Fl_Callback*)cb_vout_CurRadius);
          o->deactivate();
        }
        o->end();
      }
      o->end();
    }
    { Fl_Group* o = grp_ProjSettings = new Fl_Group(10, 370, 705, 90);
      o->box(FL_ENGRAVED_FRAME);
      o->hide();
      o->deactivate();
      { Fl_Button* o = btn_PrjSave = new Fl_Button(375, 425, 110, 25, "Save");
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_btn_PrjSave);
        o->deactivate();
      }
      { Fl_Input* o = tin_DefRad = new Fl_Input(85, 375, 105, 85, "Radius : ");
        o->box(FL_THIN_DOWN_BOX);
        o->hide();
      }
      { Fl_Input* o = tin_DefBox = new Fl_Input(250, 375, 465, 85, " Box : ");
        o->box(FL_THIN_DOWN_BOX);
        o->hide();
      }
      { Fl_Button* o = btn_PrjClear = new Fl_Button(250, 425, 115, 25, "Clear");
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_btn_PrjClear);
      }
      { Fl_Check_Button* o = btn_Autosave_ = new Fl_Check_Button(475, 390, 25, 25, "Autosave");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->callback((Fl_Callback*)cb_btn_Autosave_);
      }
      { Fl_Input* o = tin_Name = new Fl_Input(485, 425, 110, 25);
        o->hide();
      }
      o->end();
    }
    { Fl_Group* o = grp_Ethan_Config = new Fl_Group(370, 350, 345, 100);
      o->box(FL_ENGRAVED_FRAME);
      o->align(FL_ALIGN_LEFT);
      o->hide();
      { Fl_Output* o = tout_EthanCfg = new Fl_Output(470, 390, 175, 25, "Config file:");
        o->box(FL_THIN_DOWN_BOX);
        o->deactivate();
      }
      { Fl_Button* o = btn_EthanCfgBrowse = new Fl_Button(560, 420, 80, 25, "Browse");
        o->callback((Fl_Callback*)cb_btn_EthanCfgBrowse);
        o->deactivate();
      }
      { Fl_Group* o = new Fl_Group(415, 365, 240, 20);
        { Fl_Check_Button* o = new Fl_Check_Button(460, 365, 20, 20, " Default");
          o->type(102);
          o->down_box(FL_DIAMOND_DOWN_BOX);
          o->value(1);
          o->callback((Fl_Callback*)cb_Default1);
        }
        { Fl_Check_Button* o = new Fl_Check_Button(560, 365, 20, 20, "Custom");
          o->type(102);
          o->down_box(FL_DIAMOND_DOWN_BOX);
          o->callback((Fl_Callback*)cb_Custom);
        }
        o->end();
      }
      { Fl_Button* o = new Fl_Button(470, 420, 80, 25, "Configure");
        o->callback((Fl_Callback*)cb_Configure);
      }
      o->end();
    }
    { Fl_Button* o = lbl_02 = new Fl_Button(25, 35, 60, 25, "Files :");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(25, 340, 100, 25, "Directories :");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
    }
    { Fl_Button* o = new Fl_Button(130, 350, 75, 25, "Project :");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
      o->hide();
    }
    { Fl_Button* o = lbl_01 = new Fl_Button(385, 340, 165, 25, "Ethan configuration :");
      o->box(FL_FLAT_BOX);
      o->labelfont(1);
      o->hide();
    }
    { Fl_Menu_Bar* o = mnu_MainMenu = new Fl_Menu_Bar(0, 0, 730, 25);
      o->menu(menu_mnu_MainMenu);
    }
    o->end();
  }
  //


int n=0;
time_t t = time(NULL);
struct stat mstat;
char pathbuf[200];
char *mch;
char *path=strdup(getenv("PATH"));


mprintf("\n*** New session: %s\n",ctime(&t));
//signal(SIGSEGV,fnc_sigsegv);

char mbuf[PATH_MAX];
getwd(mbuf);
strcat(mbuf,"/");
tout_ProjDir->value(mbuf);
tout_MRCDir->value(mbuf);

mch=strtok(path,":");
strcpy(pathbuf, mch); strcat(pathbuf,"/ethan");
if (stat(pathbuf, &mstat)==0) n=1;

while ((mch=strtok(NULL,":"))!=NULL){
	strcpy(pathbuf, mch); strcat(pathbuf,"/ethan");
	if (stat(pathbuf, &mstat)==0){ 
		n=1;
		break;
	}
}


if (n==0)  { 
	fl_alert("Unable to find ethan executable.\n Exiting.");
	mprintf(" Error: couln'd find ethan, make sure it's in the path, and try again.\n");
	mni_Exit->do_callback(NULL);
}


fnc_WriteEthanCFG("/tmp/ethan.cfg");

//
  w->show(argc, argv);
  return Fl::run();
}

void fnc_ClearMosaic() {
  Fl_Button *b;

while (scrl_Mosaic->children()>2){
	b=(Fl_Button *)scrl_Mosaic->child(0);
	scrl_Mosaic->remove(b);
	delete(b);
}
}

void fnc_FillMosaic(const char * infname) {
  PrjOutFile *ouf=OutFiles;
Fl_Button *btn;
Fileimage *a;
unsigned char *data, *ImData_;
char  path[200];
int  tsize=VBIMAGESIZE*VBIMAGESIZE, x=3,y=3;

Fl_Image *flim;
printf("Filling mosaic from file: %s\n",infname);
//========================================================
while(ouf){
	printf("Testing: %s \n",ouf->infname);
	if (strcmp(ouf->infname, infname)==0){  //tree_Proc->selected()->label())==0){
		sprintf(path,"%s%s", tout_ProjDir->value(), ouf->oufname); 
		a =new Fileimage(path);

		if (a->xSize()<VBIMAGESIZE)  // if box size was less then preset button image size
			data = a->readForViewing(0,0, a->xSize(),a->ySize(),a->xSize() );
		else
			data = a->readForViewing(0,0, a->xSize(),a->ySize(), VBIMAGESIZE);

		ImData_=(unsigned char *)malloc(tsize*3);
		for (int i=0;i<tsize;i++){
			ImData_[i*3]=data[i];
		 	ImData_[i*3+1]=data[i];
		 	ImData_[i*3+2]=data[i];
		}
		free(data);		
		if (a->xSize()<VBIMAGESIZE){
			flim=new Fl_Image(ImData_,a->xSize(),a->xSize());
			btn=new Fl_Button(scrl_Mosaic->x()+5+x,
				scrl_Mosaic->y()+5+y, a->xSize()+10,a->xSize()+10,"");
			if (x+5+10+(a->xSize()+10)*2>scrl_Mosaic->w()){
				x=3; y+=(a->xSize()+10+5);
			} else x+=(a->xSize()+10+5);
		}else{
			flim=new Fl_Image(ImData_,VBIMAGESIZE,VBIMAGESIZE);
			btn=new Fl_Button(scrl_Mosaic->x()+5+x,
				scrl_Mosaic->y()+5+y, VBSIZE,VBSIZE,"");
			if (x+5+10+VBSIZE*2>scrl_Mosaic->w()){
				x=3; y+=(VBSIZE+5);
			} else x+=(VBSIZE+5);
		}
		delete(a);
		btn->user_data((void *)ouf);

		flim->label(btn);   
		btn->type(FL_TOGGLE_BUTTON);
		scrl_Mosaic->add(btn);
	}
	ouf=ouf->next;
}


scrl_Mosaic->redraw();
}

int fnc_FileExists(char *path) {
  FILE *fp=fopen(path, "r");
if (fp) {
	fclose(fp);
	return 1;
}else return 0;
}

void fnc_sigsegv(int n) {
  //perror("Shit!");
delete(rsrv);
//printf("errno: %d, n:%d\n",errno,n);
int a;
int e=errno;

if (e==12){  //outta memory
	mprintf(" Error: out of memory!\n");
	a=fl_ask(" SPADE has ran out of memory. \n It will now terminate.\n Attempt to save the project?");
	if (a==0) exit(0);
	else{
		if (btn_PrjSave->active()) btn_PrjSave->do_callback();
		else printf("SPADE was unable to save the project.\n");
	}
}else{
	fl_alert(" An internal error has occured. \n Signal: SIGSEGV, errno : %d : %s\n SPADE will now exit. ", e, strerror(e));
	mprintf(" Error: segmentation fault, errno: %d : %s \n", e, strerror(e));
	mni_Exit->do_callback(NULL);
}

time_t t=time(NULL);
mprintf("*** Session closed: %s\n",ctime(&t));
exit(0);
}

int fnc_IsDir(char *path ) {
  //  This routine checks if path leads to a directory
//   and whether this user is allowed to readwrite this direcory
//   returns bitcode - 1: directory 2: writable 4: readable



int r=0;
struct stat mstat;
stat(path, &mstat);
gid_t mgroups[40];
int grp=getgroups(40, mgroups);
//printf("Number of groups: %d\n",grp);

if (S_ISDIR(mstat.st_mode)){
	r|=1;
	if ((mstat.st_mode & S_IWOTH)>0) r|=2;
//	printf("Dirgid: %d, my gid %d\n",mstat.st_gid,getgid());
//	printf("Diruid: %d, my uid %d\n",mstat.st_uid,getuid());
//	printf("S_IWOTH: %d, WGRP: %d, WUSR: %d\n",
//		(mstat.st_mode & S_IWOTH)>0, 
//		(mstat.st_mode & S_IWGRP)>0,
//		(mstat.st_mode & S_IWUSR)>0);

	if ((mstat.st_mode & S_IWGRP)>0){
		for (int i=0;i<grp;i++)
			if (mstat.st_gid==mgroups[i]) r|=2;
	}
	if  (((mstat.st_mode & S_IWUSR)>0) &&
		(mstat.st_uid==getuid())) r|=2;

	if ((mstat.st_mode & S_IROTH)>0) r|= 4;
	if ((mstat.st_mode & S_IRGRP)>0){
		for (int i=0;i<grp;i++) 
			if (mstat.st_gid==mgroups[i]) r|=4;
	}
	if  (((mstat.st_mode & S_IRUSR)>0) &&
		(mstat.st_uid==getuid())) r|=4;

} 
//printf("r: %d\n",r);
return r;
}

void fnc_ClearEthanCFG() {
  //

vin_EthanParHeight->value(0.5);
vin_EthanParWidth->value(1.0);
vin_EthanParRWidth->value(1.2);
vin_EthanParDist->value(0.1);
vin_EthanParReduct->value(0);
chb_EthanParResIm->value(0);
chb_EthanParRefine->set();

chb_EthanTestSector->set();
chb_EthanTestHeight->set();
chb_EthanTestDistance->set();

//
}

void fnc_WriteEthanCFG(char *path) {
  //


FILE *fp=fopen(path, "w");

if (fp==NULL) {
//	printf("before alerta\n");
	fl_alert("Couldn't open temporary ethan configration file.");
	time_t t=time(NULL);
	mprintf("Emergency exit: due to configutaion problems, couldn't write temorary ethan config, in /tmp.");
	mprintf("*** Session closed: %s\n",ctime(&t));   // log exit.
	exit(0);
}

//perror("fncwritecfg");

fprintf(fp, "HEIGHT_PARAM                 %f\n", vin_EthanParHeight->value());
fprintf(fp, "SQUARE_WIDTH_PARAM %f\n", vin_EthanParWidth->value());
fprintf(fp, "RING_WIDTH_PARAM       %f\n", vin_EthanParRWidth->value());
fprintf(fp, "DIST_PARAM                      %f\n", vin_EthanParDist->value());
fprintf(fp, "REDUCTION_PARAM         %d\n", (int)(vin_EthanParReduct->value()));
fprintf(fp, "MAKE_RESULT_IMAGE     %d\n", chb_EthanParResIm->value());
fprintf(fp, "REFINEMENT_PARAM      %d\n", chb_EthanParRefine->value());

fprintf(fp, "SECTOR_TEST                   %d\n", chb_EthanTestSector->value());
fprintf(fp, "HEIGHT_TEST                    %d\n", chb_EthanTestHeight->value());
fprintf(fp, "DISTANCE_TEST               %d\n", chb_EthanTestDistance->value());

fclose(fp);
chmod(path, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
}

void fnc_PackEthanCFG(EthanCFG *cfg) {
  cfg->EthanParHeight      = vin_EthanParHeight->value();
cfg->EthanParWidth       =vin_EthanParWidth->value();
cfg->EthanParRWidth     =vin_EthanParRWidth->value();
cfg->EthanParDist           =vin_EthanParDist->value();
cfg->EthanParReduct      =vin_EthanParReduct->value();
cfg->EthanParResIm       =chb_EthanParResIm->value();
cfg->EthanParRefine        =chb_EthanParRefine->value();
cfg->EthanTestSector      =chb_EthanTestSector->value();
cfg->EthanTestHeight      =chb_EthanTestHeight->value();
cfg->EthanTestDistance  =chb_EthanTestDistance ->value();
cfg->filename[0]=0;
}

void fnc_UnPackEthanCFG(EthanCFG *cfg) {
  vin_EthanParHeight->value(cfg->EthanParHeight);
vin_EthanParWidth->value(cfg->EthanParWidth);
vin_EthanParRWidth->value(cfg->EthanParRWidth);
vin_EthanParDist->value(cfg->EthanParDist );
vin_EthanParReduct->value(cfg->EthanParReduct);
chb_EthanParResIm->value(cfg->EthanParResIm);
chb_EthanParRefine->value(cfg->EthanParRefine);
chb_EthanTestSector->value(cfg->EthanTestSector);
chb_EthanTestHeight->value(cfg->EthanTestHeight);
chb_EthanTestDistance ->value(cfg->EthanTestDistance);
}
